/*	Marilyn: In the Magic World - Source code
	(?)2014 Meido-Tek Productions (Lameguy64)
	
	Compile with -O3 using the PsyQ SDK which can be found here:
	http://psxdev.net/downloads/PSYQ_SDK.zip
	
	
	Currently, the code is poorly structured in places and there are not that
	many comments in it for now as I have to get this out quickly for the PSXDEV
	Codeblast '14 competition.
	
	
	For links to Kenny Anderson's DeviantART page and others, check the readme.txt
	file that came with the game.
	
	
	Feel free to use any part of this code for your own productions as long as
	you put my name (Lameguy64) somewhere in your work.
	
*/


// Standard defines
#define false	0
#define true	1


// Platform defines
#define PSX		0

#define PLATFORM	PSX


// Some developer stuff
#define DEBUG		false


#include "hit_defs.h"
#include "obj_defs.h"
#include "sec_defs.h"


// Include the engine header
#if PLATFORM == PSX
	#define GAME_VERSION "VERSION 0.12A"
	#include "psx_code\engine_psx.h"
#endif


// Global stuff
#include "globals.h"


// Include the engine code
#if PLATFORM == PSX
#include "psx_code\engine_psx.c"
#endif


int main() {
	
	int i,p,up=0,dp=0,sel;
	PLAYERSTUFF BlankPlayer={0};
	
	init();
	
	BackToMenu:
	switch(DoMainMenu()) {
		case 1: // Play main game
			LoadGameGraphics();
			
			NumPlayers = 1;
			Player[0].Lives = Player[1].Lives = 5;
			PlayerStats.CoinCount = 0;
			PlayerStats.KeyCount = 0;
			
			switch(PlayLevel(&PackTOC[1], PackTOC[1].File[PlayLevelNum].Name)) {
				default:
					break;
			}
			
			goto BackToMenu;
			break;
			
		case 2: // Exit to CD menu
			ReturnToCdMenu();
			break;
			
	}
	
}
int DoMainMenu() {
	
	static int	LogoDone=0;
	
	PLAYERINPUT	BlankInput={0};
	
	int			i,a=0,MenuPage=0;
	int			ReturnVal=0;
	
	short		MenuSel=0;
	short		Accept=0,Back=0;
	short		AcceptPressed=0,BackPressed=0;
	short		ShowLogo;
	
	short		LevelListYpos,LevelListYrange;
	
	GsSPRITE	TitleLogo;
	
	
	LVLHEADER	LevelHeader;
	GsSPRITE	FGtileSprite[255];
	GsCELL		BGtileCell[384];
	
	LvlHeader_ptr		= &LevelHeader;
	FGtileSprite_ptr	= FGtileSprite;
	BGtileCell_ptr		= BGtileCell;
	
	
	// Load the title screen images and background
	LoadTitleGraphics();
	LoadLevelHeader(&PackTOC[0], "TITLE.MLV");
	
	TitleLogo = PrepSprite(TempTim[2]);
	
	
	XAsetup(2);
	XAplayChannel(&XAfiles[0], 0, true);
	
	
	if (LogoDone == false) {
		DoLogoStuff();
		LogoDone = true;
	}
	
	
	ClearColor = LevelHeader.ClearColor;
	Camera.x = Camera.y = 0;
	TitleLogo.mx = TitleLogo.w / 2;
	TitleLogo.my = TitleLogo.h / 2;
	TransitionIn();
	
	while(1) {
		
		PrepDisplay();
		PauseAll = PAUSE_OFF;
		DoTransitions();
		
		if ((TransOnGoing == false) && (ReturnVal == false)) GetInput();	else	PlayerInput[0] = BlankInput;
		
		
		Accept = false;
		if ((PlayerInput[0].jump) || (PlayerInput[0].pause)) {
			if (AcceptPressed == false) Accept = true;
			AcceptPressed = true;
		} else {
			AcceptPressed = false;
		}
		
		Back = false;
		if ((PlayerInput[0].throw) || (PlayerInput[0].run)) {
			if (BackPressed == false) Back = true;
			BackPressed = true;
		} else {
			BackPressed = false;
		}
		
		
		StringTemp[0] = 0;
		
		ShowLogo = true;
		switch (MenuPage) {
			case 0:	// Press start
				if (TransOnGoing == false) {
					if (Bobbing == 0) DrawText("Press Start", CENTERED, 150, 0, 128, 128, 128);
					
					// Draw game version and some acknowledgement text
					DrawTextSmall(GAME_VERSION, CenterPosX + 16, 200, 0, 128, 128, 128);
					DrawText("Marilyn and related characters (C)2014 Kenny Anderson", CENTERED, 210, 0, 128, 128, 128);
					DrawText("Fan-game developed by Meido-Tek Productions", CENTERED, 220, 0, 128, 128, 128);
		
					if (Accept) {
						PlaySound(SND_SELECT, -1, ONE, 0);
						MenuPage = 1;
					}
					
				}
				break;
				
			case 1:	// Main menu
				
				if (MenuPage) {
					if (PlayerInput[0].tap_up) {
						PlaySound(SND_CHOOSE, -1, ONE, 0);
						MenuSel -= 1;
					}
					
					if (PlayerInput[0].tap_down) {
						PlaySound(SND_CHOOSE, -1, ONE, 0);
						MenuSel += 1;
					}
				}
		
				if (MenuSel < 0) MenuSel = 3;
				if (MenuSel > 3) MenuSel = 0;

				
				DrawText("Start Game", CENTERED, 132, 0, 128, 128, 128);
				DrawText("Options", CENTERED, 142, 0, 128, 128, 128);
				DrawText("Credits", CENTERED, 152, 0, 128, 128, 128);
				if (MenuPresent == false) {
					DrawText("Exit", CENTERED, 162, 0, 64, 64, 64);
				} else {
					DrawText("Exit", CENTERED, 162, 0, 128, 128, 128);
				}
				
				
				DrawUiCell((ScreenCenterX-40)+Bobbing, 132 + (10*MenuSel), 5, 3, 8, 8, 0, 128, 128, 128);
				DrawUiCell((ScreenCenterX+33)-Bobbing, 132 + (10*MenuSel), 5, 2, 8, 8, 0, 128, 128, 128);
				
				DrawMenuPanel(ScreenCenterX-50, 120, ScreenCenterX+50, 180, false);
				
				CharTemp[0] = CHR_UP;		strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_DOWN;		strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Select ");
				
				CharTemp[0] = CHR_CROSS;	strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Accept ");
				
				CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Back ");
				
				
				if (Accept) {
					switch(MenuSel) {
						case 0:
							PlaySound(SND_SELECT, -1, ONE, 0);
							MenuSel = 0;
							MenuPage = 2;
							break;
						case 1:
							PlaySound(SND_SELECT, -1, ONE, 0);
							MenuSel = 0;
							MenuPage = 3;
							break;
						case 2:
							PlaySound(SND_SELECT, -1, ONE, 0);
							MenuPage = 4;
							break;
						case 3:
							if (MenuPresent) {
								PlaySound(SND_SELECT, -1, ONE, 0);
								TransitionOut();
								ReturnVal=2;
							} else {
								PlaySound(SND_DENIED, -1, ONE, 0);
							}
							break;
					}
				}
				
				if (Back) {
					PlaySound(SND_RETURN, -1, ONE, 0);
					MenuPage = 0;
				}
				
				break;
			
			case 2: // Level selector
				
				if (PlayerInput[0].tap_up) {
					PlaySound(SND_CHOOSE, -1, ONE, 0);
					MenuSel -= 1;
				}
				
				if (PlayerInput[0].tap_down) {
					PlaySound(SND_CHOOSE, -1, ONE, 0);
					MenuSel += 1;
				}
				
				if (MenuSel < 0) MenuSel = PackTOC[1].NumFiles - 1;
				if (MenuSel > (PackTOC[1].NumFiles - 1)) MenuSel = 0;
				
				if (MenuSel < LevelListYpos) LevelListYpos = MenuSel;
				if (MenuSel > LevelListYpos + 5) LevelListYpos = MenuSel - 5;
				
				
				LevelListYrange = PackTOC[1].NumFiles;
				if (LevelListYrange > 6) LevelListYrange = 6;
				for (i=0; i<LevelListYrange; i++) {
					DrawText(PackTOC[1].File[i+LevelListYpos].Name, ScreenCenterX - 40, 130 + (10 * i), 0, 128, 128, 128);
				}
				
				DrawVScrollBar(ScreenCenterX + 44, 127, 70, MenuSel, PackTOC[1].NumFiles-1);
				
				DrawText("Select a Level", CENTERED, 112, 0, 128, 128, 128);
				DrawUiCell((ScreenCenterX-50)+Bobbing, 130 + (10*(MenuSel-LevelListYpos)), 5, 3, 8, 8, 0, 128, 128, 128);
				
				DrawMenuPanel(ScreenCenterX-60, 118, ScreenCenterX+60, 198, false);
				
				CharTemp[0] = CHR_UP;		strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_DOWN;		strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Select ");
				
				CharTemp[0] = CHR_CROSS;	strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Play! ");
				
				CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Back ");
				
				if (Accept) {
					PlaySound(SND_SELECT, -1, ONE, 0);
					PlayLevelNum = MenuSel;
					TransitionOut();
					ReturnVal=1;
				}
				
				if (Back) {
					PlaySound(SND_RETURN, -1, ONE, 0);
					MenuPage = 1;
					MenuSel = 0;
				}
				
				break;
				
			case 3:	// Options menu
				
				CharTemp[0] = CHR_UP;		strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_DOWN;		strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Select ");
				
				DoOptionsStuff(&MenuSel, &PlayerInput[0]);
				
				if (Back) {
					if (ScreenAdjustMode == false) {
						PlaySound(SND_RETURN, -1, ONE, 0);
						MenuPage = 1;
						MenuSel = 0;
					} else {
						ScreenAdjustMode=0;
					}
				}
				
				ShowLogo = false;
				break;
			
			case 4: // Basic credits
				
				ShowLogo = false;
				
				DrawText("Game Credits:", CENTERED, 40, 0, 128, 128, 128);
				
				DrawText("Marilyn and related characters by:", CENTERED, 60, 0, 128, 128, 128);
				DrawText("Kenny Anderson (nerdsman567)", CENTERED, 70, 0, 128, 128, 128);
				
				DrawText("Game programming, graphics, and levels by:", CENTERED, 90, 0, 128, 128, 128);
				DrawText("Jobert Villamor (RGBAguy/Lameguy64)", CENTERED, 100, 0, 128, 128, 128);
				
				DrawText("Featuring music composed by:", CENTERED, 120, 0, 128, 128, 128);
				DrawText("Hydra/Anarchy PC", CENTERED, 130, 0, 128, 128, 128);
				DrawText("Benjamin Gerardin", CENTERED, 140, 0, 128, 128, 128);
				DrawText("Sami Wilenius", CENTERED, 150, 0, 128, 128, 128);
				DrawText("Pixel", CENTERED, 160, 0, 128, 128, 128);
				DrawText("(See readme.txt in the game disc for more details)", CENTERED, 180, 0, 128, 128, 128);
				
				CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
				CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
				CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
				strcat(StringTemp, "-Back ");
				
				if (Back) {
					PlaySound(SND_RETURN, -1, ONE, 0);
					MenuPage = 1;
					MenuSel = 0;
				}
				
				break;
				
		}
		
		
		// Draw the title logo
		if (ShowLogo) {
			TitleLogo.x = ScreenCenterX - TitleLogo.mx;
			TitleLogo.y = (ScreenCenterY - 60) - TitleLogo.my;
			TitleLogo.y += ((rsin(ONE*((float)a/360))*4)+2048)/ONE;
			GsSortFastSprite(&TitleLogo, &myOT[myActiveBuff], 0);
		}
		a = (a + 1) % 360;
		
		if (MenuPage) DrawText(StringTemp, CENTERED, ScreenYres - 24, 0, 128, 128, 128);
		
		DrawBG();
		
		Display();
		
		if ((ReturnVal) && (TransOnGoing == false)) {
			XAremove();
			return(ReturnVal);
		}
		
	}
	
	
}
void DoOptionsStuff(short *MenuSel, PLAYERINPUT *istuff) {
	
	int CursorY;
	
	if (ScreenAdjustMode == false) {
		
		if (PlayerInput[0].tap_up) {
			PlaySound(SND_CHOOSE, -1, ONE, 0);
			*MenuSel -= 1;
		}
		
		if (PlayerInput[0].tap_down) {
			PlaySound(SND_CHOOSE, -1, ONE, 0);
			*MenuSel += 1;
		}
		
	} else {
		
		if ((PlayerInput[0].tap_up) && (DisplayYpos > -32)) {
			DisplayYpos -= 2;
			if (VideoMode == 0) SetNTSC(); else SetPAL();
		}
		
		if ((PlayerInput[0].tap_down) && (DisplayYpos < 32)) {
			DisplayYpos += 2;
			if (VideoMode == 0) SetNTSC(); else SetPAL();
		}
		
		if ((PlayerInput[0].tap_left) && (DisplayXpos > -32)) {
			DisplayXpos -= 2;
			if (VideoMode == 0) SetNTSC(); else SetPAL();
		}
		
		if ((PlayerInput[0].tap_right) && (DisplayXpos < 32)) {
			DisplayXpos += 2;
			if (VideoMode == 0) SetNTSC(); else SetPAL();
		}
		
	}
	
	if (*MenuSel < 0) *MenuSel = 7;
	if (*MenuSel > 7) *MenuSel = 0;
	
	
	if (ScreenAdjustMode == false) {
		switch(*MenuSel) {
			case 0:
				if ((PlayerInput[0].tap_left) && (ss_cdvol > 0)) {
					ss_cdvol -= 5;
					XAsetVolume(ss_cdvol, ss_cdvol);
				}
				if ((PlayerInput[0].tap_right) && (ss_cdvol < 125)) {
					ss_cdvol += 5;
					XAsetVolume(ss_cdvol, ss_cdvol);
				}
				break;
			case 1:
				if ((PlayerInput[0].tap_left) && (ss_sfxvol > 0)) {
					PlaySound(SND_CHOOSE, -1, ONE, 0);
					ss_sfxvol -= 15;
				}
				if ((PlayerInput[0].tap_right) && (ss_sfxvol < 255)) {
					PlaySound(SND_CHOOSE, -1, ONE, 0);
					ss_sfxvol += 15;
				}
				break;
			case 2:
				if (PlayerInput[0].tap_jump) {
					PlaySound(SND_SELECT, -1, ONE, 0);
					ss_stereo ^= 1;
					if (ss_stereo) {
						SsSetStereo();
					} else {
						SsSetMono();
					}
				}
				break;
			case 3:
				if (PlayerInput[0].tap_jump) {
					PlaySound(SND_SELECT, -1, ONE, 0);
					AspectMode ^= 1;
					if (AspectMode) Set16x9(); else Set4x3();
				}
				break;
			case 4:
				if (PlayerInput[0].tap_jump) {
					PlaySound(SND_SELECT, -1, ONE, 0);
					VideoMode ^= 1;
					if (VideoMode) SetPAL(); else SetNTSC();
				}
				break;
			case 5:
				if (PlayerInput[0].tap_jump) {
					PlaySound(SND_SELECT, -1, ONE, 0);
					ScreenAdjustMode=1;
				}
				break;
			case 6:
				if (PlayerInput[0].tap_jump) PlaySound(SND_DENIED, -1, ONE, 0);
				break;
			case 7:
				if (PlayerInput[0].tap_jump) PlaySound(SND_DENIED, -1, ONE, 0);
				break;
		}
	}
	
	
	CursorY = 65+(10* *MenuSel);
	if (*MenuSel > 2) CursorY += 10;
	if (*MenuSel > 5) CursorY += 10;
	if (*MenuSel > 6) CursorY += 10;
	DrawUiCell((ScreenCenterX-105)+Bobbing, CursorY, 5, 3, 8, 8, 0, 128, 128, 128);
	
	
	if (ScreenAdjustMode) {
		
		DrawText("Screen adjustment mode", CENTERED, 112, 0, 128, 128, 128);
		
		sprintf(StringTemp2, "(X:%d Y:%d)", DisplayXpos, DisplayYpos);
		DrawText(StringTemp2, CENTERED, 122, 0, 128, 128, 128);
		DrawMenuPanel(ScreenCenterX-80, 100, ScreenCenterX+80, 140, false);
		
	}
	
	
	DrawText("Options", CENTERED, 46, 0, 128, 128, 128);
	
	// Sound settings
	DrawText("Music volume:", ScreenCenterX - 95, 65, 0, 128, 128, 128);
	DrawText("SFX volume:", ScreenCenterX - 95, 75, 0, 128, 128, 128);
	
	DrawHScrollBar(ScreenCenterX - 20, 65, 130, ss_cdvol, 125);
	DrawHScrollBar(ScreenCenterX - 20, 75, 130, ss_sfxvol, 255);
	
	StringTemp2[0] = 0;
	strcat(StringTemp2, "Sound setup: ");
	if (ss_stereo) strcat(StringTemp2, "Stereo"); else strcat(StringTemp2, "Mono");
	DrawText(StringTemp2, ScreenCenterX - 95, 85, 0, 128, 128, 128);
	
	
	// Video settings
	StringTemp2[0] = 0;
	strcat(StringTemp2, "Display mode: ");
	if (AspectMode) strcat(StringTemp2, "Widescreen (16:9)"); else strcat(StringTemp2, "Normal (4:3)");
	DrawText(StringTemp2, ScreenCenterX - 95, 105, 0, 128, 128, 128);
	
	StringTemp2[0] = 0;
	strcat(StringTemp2, "Video mode: ");
	if (VideoMode) strcat(StringTemp2, "PAL (not recommended)"); else strcat(StringTemp2, "NTSC");
	DrawText(StringTemp2, ScreenCenterX - 95, 115, 0, 128, 128, 128);
	DrawText("Adjust screen position", ScreenCenterX - 95, 125, 0, 128, 128, 128);
	
	
	// Other
	DrawText("Create save block", ScreenCenterX - 95, 145, 0, 64, 64, 64);
	
	DrawText("Save changes", ScreenCenterX - 95, 165, 0, 64, 64, 64);
	
	DrawMenuPanel(ScreenCenterX-115, 51, ScreenCenterX+115, 185, false);
	
	switch(*MenuSel) {
		case 0:
		case 1:
			CharTemp[0] = CHR_LEFT;		strcat(StringTemp, CharTemp);
			CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
			CharTemp[0] = CHR_RIGHT;	strcat(StringTemp, CharTemp);
			strcat(StringTemp, "-Adjust ");
			break;
		case 5:
		case 6:
		case 7:
			CharTemp[0] = CHR_CROSS;	strcat(StringTemp, CharTemp);
			strcat(StringTemp, "-Accept ");
			break;
		default:
			CharTemp[0] = CHR_CROSS;	strcat(StringTemp, CharTemp);
			strcat(StringTemp, "-Change ");
			break;
	}
		
	CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
	CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
	CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
	strcat(StringTemp, "-Back ");
	
	if (ScreenAdjustMode) {
	
		StringTemp[0] = 0;
		CharTemp[0] = CHR_UP;		strcat(StringTemp, CharTemp);
		CharTemp[0] = CHR_DOWN;		strcat(StringTemp, CharTemp);
		CharTemp[0] = CHR_LEFT;		strcat(StringTemp, CharTemp);
		CharTemp[0] = CHR_RIGHT;	strcat(StringTemp, CharTemp);
		strcat(StringTemp, "-Move Screen ");

		CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
		CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
		CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
		strcat(StringTemp, "-Done ");

	}
	
}
void DoLogoStuff() {
	
	int i;
	GsBOXF		box = { (1<<28)|(1<<30), 0, 0, ScreenXres, ScreenYres, 0, 0, 0 };
	GsSPRITE	LogoSprite = PrepSprite(TempTim[1]);
	
	
	ClearColor.red = 255;
	ClearColor.grn = 255;
	ClearColor.blu = 255;
	
	TransitionIn();
	while(TransOnGoing) {
		
		PrepDisplay();
		DoTransitions();
		
		SortImage(CenterPosX, 0, TempTim[0], 128, 128, 128);
		Display();
		
	}
	
	for (i=0;i<120;i+=1) VSync(0);
	
	
	i = 0;
	while(i < 255) {
		
		PrepDisplay();
		
		i += 8;
		if (i > 255) i = 255;
		
		box.r = box.g = box.b = i;
		GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
		
		SortImage(CenterPosX, 0, TempTim[0], 128, 128, 128);
		Display();
		
	}
	
	
	LogoSprite.x = ScreenCenterX;
	LogoSprite.y = ScreenCenterY;
	LogoSprite.mx = LogoSprite.w / 2;
	LogoSprite.my = LogoSprite.h / 2;
	
	LogoSprite.scalex = LogoSprite.scaley = ONE*7;
	
	while(LogoSprite.scalex > 4150) {
		PrepDisplay();
		LogoSprite.scalex += ((4096 - LogoSprite.scalex) / 16);
		LogoSprite.scaley += ((4096 - LogoSprite.scaley) / 16);
		
		box.r = box.g = box.b = (LogoSprite.scalex - ONE) / 97;
		GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
		
		GsSortSprite(&LogoSprite, &myOT[myActiveBuff], 0);
		Display();
	}
	
	LogoSprite.scalex = LogoSprite.scaley = ONE;	
	for (i=0;i<120;i+=1) {
		PrepDisplay();
		GsSortSprite(&LogoSprite, &myOT[myActiveBuff], 0);
		Display();
	}
	
	TransitionOut();
	while(TransOnGoing) {
		PrepDisplay();
		DoTransitions();
		GsSortSprite(&LogoSprite, &myOT[myActiveBuff], 0);
		Display();
	}
	
}

void DoPlayerLogic(PLAYERSTUFF *pstuff, PLAYERINPUT *istuff) {
	
	int i,s;
	
	if (PauseAll != PAUSE_ALL) {
		if (pstuff->Death == false) {
			if (pstuff->HurtCount != 1) {
			
				if (pstuff->ThrowCount == 0) {
					
					// Looking
					if (pstuff->OnFloor) {
						if (istuff->up) {			// Up
							if (pstuff->Look > 0)		pstuff->Look = 0;
							if (pstuff->Look > -240)	pstuff->Look -= 1;
						} else if (istuff->down) {	// Down
							if (pstuff->Look < 0)		pstuff->Look = 0;
							if (pstuff->Look < 240) 	pstuff->Look += 1;
						} else {
							pstuff->Look = 0;
						}
					}
					
					// Movement
					if ((pstuff->Stuck == false) && (pstuff->Look == 0)) {
						if (istuff->left) {
							if (pstuff->OnFloor) {
								pstuff->xMove -= 800;
								if (istuff->run) {
									if (pstuff->xMove < -(ONE * 4)) pstuff->xMove = -(ONE * 4);
								} else {
									if (pstuff->xMove < -(ONE * 2)) pstuff->xMove = -(ONE * 2);
								}
							} else {
								if (istuff->run) {
									if (pstuff->xMove > -(ONE * 3)) pstuff->xMove -= 800;
								} else {
									if (pstuff->xMove > -(ONE * 2)) pstuff->xMove -= 800;
								}
							}
							pstuff->Dir = -1;
						}
						
						if (istuff->right) {
							if (pstuff->OnFloor) {
								pstuff->xMove += 800;
								if (istuff->run) {
									if (pstuff->xMove > (ONE * 4)) pstuff->xMove = (ONE * 4);
								} else {
									if (pstuff->xMove > (ONE * 2)) pstuff->xMove = (ONE * 2);
								}
							} else {
								if (istuff->run) {
									if (pstuff->xMove < (ONE * 3)) pstuff->xMove += 800;
								} else {
									if (pstuff->xMove < (ONE * 2)) pstuff->xMove += 800;
								}
							}
							pstuff->Dir = 1;
						}
					}
					
					// Shooting
					if (istuff->run) {
						if ((pstuff->ShootPressed == false) && (pstuff->ShootCount == 0)) {
							switch (pstuff->PowerState) {
								case ENT_FIREBOW:
									PlaySound(SND_SHOOT1, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
									pstuff->ShootCount = 1;
									if (pstuff->Dir > 0) {
										AddProjectile(pstuff->x+8, pstuff->y-8, 4*ONE, 2*ONE, PROJ_FIREBALL, 0);
									} else {
										AddProjectile(pstuff->x-8, pstuff->y-8, -(4*ONE), 2*ONE, PROJ_FIREBALL, 0);
									}
									break;
							}
						}
						pstuff->ShootPressed = true;
					} else {
						pstuff->ShootPressed = false;
					}
					
					if (pstuff->ShootCount) {
						pstuff->ShootCount += 1;
						if (pstuff->ShootCount >= 10)	pstuff->ShootCount = 0;
					}
					
					// Jumping
					if (pstuff->OnFloor) pstuff->Jump = false;
					if (istuff->jump) {
						if ((pstuff->Stuck == false) && (pstuff->JumpPressed == false) 
						&& (pstuff->Jump == false) && (pstuff->OnFloor)) {
							PlaySound(SND_JUMP, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
							pstuff->yMove = -(8704 + abs(pstuff->xMove / 6));
							pstuff->Jump = true;
							pstuff->JumpCount = 0;
						}
						pstuff->JumpPressed = true;
					} else {
						pstuff->JumpPressed = false;
						pstuff->Jump = false;
					}
					
					// Throw meibi
					if (istuff->throw) {
						if (LvlHeader_ptr->Flags.NoFairy == false) {
							if ((pstuff->ThrowPressed == false) && (pstuff->Look == 0) && (pstuff->ThrowCount == 0) && pstuff->Fairy.LaunchCount == 0) {
								pstuff->ThrowCount = 1;
							}
						}
						pstuff->ThrowPressed = true;
					} else {
						pstuff->ThrowPressed = false;
					}
					
				} else {
					
					pstuff->ThrowCount += 1;
					if (pstuff->ThrowCount > 20)	pstuff->ThrowCount = 0;
					
				}
				
				if (pstuff->HurtCount >= 2)		pstuff->HurtCount += 1;
				if (pstuff->HurtCount >= 120)	pstuff->HurtCount = 0;
				
			} else {
				
				if ((pstuff->OnFloor) && (pstuff->HurtCount == 1))	pstuff->HurtCount = 2;
				pstuff->JumpPressed = false;
				
				pstuff->ThrowCount = 0;
				pstuff->Fairy.LaunchCount = 0;
				
			}
			
			if ((pstuff->JumpPressed) && (pstuff->Jump) && (pstuff->JumpCount < 12)) {
				pstuff->yMove -= 850;
				pstuff->JumpCount += 1;
			}
			
			if (pstuff->xMove > (ONE * 4)) pstuff->xMove = (ONE * 4);
			if (pstuff->xMove < -(ONE * 4)) pstuff->xMove = -(ONE * 4);
			
			pstuff->yMove += GRAVITY;
			if (pstuff->yMove > ONE * FALL_LIMIT) pstuff->yMove = ONE * FALL_LIMIT;
			
			pstuff->fx += pstuff->xMove;
			pstuff->fy += pstuff->yMove;
			
			if (pstuff->HurtCount != 1) {
				if (pstuff->OnFloor)	{
					i = abs(pstuff->xMove);
					if (i > 384)	i=384;
					if (pstuff->xMove > 0) {
						pstuff->xMove -= i;
					} else if (pstuff->xMove < 0) {
						pstuff->xMove += i;
					}
				} else {
					i = abs(pstuff->xMove);
					if (i > 256)	i=256;
					if (pstuff->xMove > 0) {
						pstuff->xMove -= i;
					} else if (pstuff->xMove < 0) {
						pstuff->xMove += i;
					}
				}
			}
			
			pstuff->DeadCount = 0;
			
		} else {	// Do death animation
			
			pstuff->PowerState = 0;
			pstuff->xMove = 0;
			
			pstuff->DeadCount += 1;
			if (pstuff->FallOff == false) {
				if (pstuff->DeadCount >= 30) {
					if (pstuff->y < 16 * (LvlHeader_ptr->ydim + 4)) {
						pstuff->yMove += GRAVITY;
						pstuff->fy = pstuff->fy + pstuff->yMove;
					}
				} else {
					pstuff->yMove = 0;
				}
			}
			
			if (pstuff->DeadCount == 30) {
				PlaySound(SND_DEATH, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
				pstuff->yMove = -ONE * 4;
			}
			
			if (pstuff->DeadCount > 120)	pstuff->DoneFor = true;
			
		}
		
	}

	// Convert player's coordinates from fixed-point
	pstuff->x = pstuff->fx / ONE;
	pstuff->y = pstuff->fy / ONE;
	
	// Do collision detection
	DoPlayerCollision(pstuff);
	
	// Do sector detection
	s = InSector(pstuff->x, pstuff->y);
	if (s >= 0) {
		switch (SectorList_ptr[s].hitag) {
			case SEC_DIALOGTRIGGER:
				if (TransOnGoing == false) {
					StartDialog(SectorList_ptr[s].lotag);
					//SectorList_ptr[s].hitag = 0;
					DeleteSector(s);
				}
				break;
			case SEC_SIGNPOST:
				if ((istuff->up) && (DialogState == 0)) StartDialog(SectorList_ptr[s].lotag);
				break;
			case SEC_DOORWAY:
				if ((TransOnGoing == false) && (pstuff->OnFloor) && (istuff->up) && (pstuff->DoorEntryState == 0)) {
					pstuff->DoorEntryState = 1;
					pstuff->DoorEntrySector = s;
					pstuff->DoorEntryTag = SectorList_ptr[s].lotag;
					TransitionOut();
				}
				break;
		}
	}
	
	// Door/teleporter stuff
	if ((pstuff->DoorEntryState) && (TransOnGoing == false)) {
		
		// Scan for a destination sector
		s = pstuff->DoorEntrySector+1;
		if (s > LvlHeader_ptr->NumSectors) s=0;
		while(1) {
			
			if (SectorList_ptr[s].hitag == SEC_DOORWAY) {
				if (SectorList_ptr[s].lotag == pstuff->DoorEntryTag) break;
			}
			
			s+=1;
			if (s > LvlHeader_ptr->NumSectors) s=0;
			
		}
		
		if (NumPlayers == 1) {
			
			pstuff->x = ((16 * SectorList_ptr[s].x1) + ((16 * SectorList_ptr[s].x2) + 15)) / 2;
			pstuff->y = (16 * SectorList_ptr[s].y2) + 15;
			pstuff->xMove = 0;
			pstuff->yMove = 0;
			
			pstuff->fx = ONE*pstuff->x;
			pstuff->fy = ONE*pstuff->y;
			
			
		} else {
			
			for (i=0; i<NumPlayers; i++) {
			
				Player[i].x = ((((16 * SectorList_ptr[s].x1) + ((16 * SectorList_ptr[s].x2) + 15)) / 2) - 2) + (4 * i);
				Player[i].y = (16 * SectorList_ptr[s].y2) + 15;
				
				Player[i].xMove = 0;
				Player[i].yMove = 0;
				
				Player[i].fx = ONE*Player[i].x;
				Player[i].fy = ONE*Player[i].y;
				
			}
			
		}
		
		pstuff->DoorEntryState = 0;
		
		FixStuff();
		
		TransitionIn();
		
	}
	
}
void DoFairyLogic(PLAYERSTUFF *pstuff, PLAYERINPUT *istuff) {
	
	int i,c,cm,cx,cy;
	int HitBreakable,HitOverride=0;
	
	if (pstuff->FairyMode == 0) {
		
		pstuff->Fairy.FlutterPressed = false;
		pstuff->Fairy.DropPressed = false;
	
		// Make meibi follow the player
		if (PauseAll != PAUSE_ALL) {
			if ((pstuff->Fairy.LaunchCount == 0) && (pstuff->Death == false)) {
				
				if (pstuff->Fairy.dx < pstuff->x - 20) pstuff->Fairy.dx = pstuff->x - 20;
				if (pstuff->Fairy.dx > pstuff->x + 20) pstuff->Fairy.dx = pstuff->x + 20;
				
				pstuff->Fairy.fx += ((ONE * pstuff->Fairy.dx) - pstuff->Fairy.fx) / 12;
				pstuff->Fairy.fy += ((ONE * (pstuff->y - 8)) - pstuff->Fairy.fy) / 12;
				
				if (pstuff->Fairy.x > pstuff->x) pstuff->Fairy.Dir = -1;
				if (pstuff->Fairy.x < pstuff->x) pstuff->Fairy.Dir = 1;
				
				pstuff->Fairy.xMove = 0;
				pstuff->Fairy.yMove = 0;
				pstuff->Fairy.FlutterCount = 0;
			}
			
			// Meibi's throw logic
			if ((pstuff->ThrowCount > 0) && (PauseAll != PAUSE_ALL)) {
				if (pstuff->ThrowCount <= 10) {
					if (pstuff->Dir > 0) {
						pstuff->Fairy.fx = ONE * (pstuff->x - 8);
					} else {
						pstuff->Fairy.fx = ONE * (pstuff->x + 9);
					}
					pstuff->Fairy.fy = ONE * (pstuff->y - 3);
					pstuff->Fairy.Dir = pstuff->Dir;
				} else if (pstuff->ThrowCount == 11) {
					if (pstuff->Fairy.LaunchCount == 0) pstuff->Fairy.LaunchCount = 1;
				}
			}
		}
		
	} else {
		
		// Meibi's controls
		if ((pstuff->Fairy.HurtCount == 0) || (pstuff->Fairy.HurtCount >= 20)) {
		
			if (istuff->run) {
				if ((pstuff->Fairy.LaunchPressed == false) && (pstuff->Fairy.LaunchCount == 0)) pstuff->Fairy.LaunchCount = 1;
				pstuff->Fairy.LaunchPressed = true;
			} else {
				pstuff->Fairy.LaunchPressed = false;
			}
			
			if (pstuff->Fairy.LaunchCount == 0) {
				
				// Flutter
				if (istuff->jump) {
					if ((pstuff->Fairy.FlutterPressed == false) && (pstuff->Fairy.FlutterCount == 0)) {
						pstuff->Fairy.yMove = -ONE*4;
						pstuff->Fairy.FlutterCount = 1;
					}
					pstuff->Fairy.FlutterPressed = true;
				} else {
					pstuff->Fairy.FlutterPressed = false;
				}
				
				// Drop
				if ((istuff->throw) && (pstuff->Fairy.FlutterCount == 0)) {
					pstuff->Fairy.DropPressed = true;
				} else {
					pstuff->Fairy.DropPressed = false;
				}
				
				// Up & down
				if ((pstuff->Fairy.FlutterCount == 0) && (pstuff->Fairy.DropPressed == 0)) {
					if (istuff->up)		pstuff->Fairy.yMove -= 1024;
					if (istuff->down)	pstuff->Fairy.yMove += 1024;
				}
				
				// Left & right
				if (istuff->left) {
					pstuff->Fairy.xMove -= 1024;
					pstuff->Fairy.Dir = -1;
				}
				if (istuff->right) {
					pstuff->Fairy.xMove += 1024;
					pstuff->Fairy.Dir = 1;
				}
				
				// Clip velocities
				if (pstuff->Fairy.xMove > ONE*2)	pstuff->Fairy.xMove = ONE*2;
				if (pstuff->Fairy.xMove < -ONE*2)	pstuff->Fairy.xMove = -ONE*2;
				
				if ((pstuff->Fairy.FlutterCount == 0) && (pstuff->Fairy.DropPressed == 0)) {
					if (pstuff->Fairy.yMove > ONE*2)	pstuff->Fairy.yMove = ONE*2;
					if (pstuff->Fairy.yMove < -ONE*2)	pstuff->Fairy.yMove = -ONE*2;
				} else if (pstuff->Fairy.FlutterCount) {
					pstuff->Fairy.FlutterCount += 1;
					if (pstuff->Fairy.FlutterCount > 20) pstuff->Fairy.FlutterCount = 0;
				} else {
					pstuff->Fairy.yMove += (GRAVITY/2);
					if (pstuff->Fairy.yMove > (ONE*FALL_LIMIT)/2) pstuff->Fairy.yMove = (ONE*FALL_LIMIT)/2;
				}
				
			}
			
		}
		
		// Timer thing
		//pstuff->Fairy.TimerCount += 1;

	}
	
	
	// Hurt recovery
	if (pstuff->Fairy.HurtCount) pstuff->Fairy.HurtCount += 1;
	if (pstuff->Fairy.HurtCount >= 180) pstuff->Fairy.HurtCount = 0;
	
	
	// If player dies, make fairy look like it saw the player die
	if (pstuff->Death) {
		
		pstuff->Fairy.LaunchCount = 0;
		pstuff->Fairy.HurtCount = 0;
		pstuff->Fairy.FlutterCount = 0;
		
	} else {
		
		if (PauseAll != PAUSE_ALL) {
			
			if ((pstuff->Fairy.LaunchCount) || (pstuff->FairyMode)) {
				
				if ((pstuff->Fairy.HurtCount == 0) || (pstuff->Fairy.HurtCount >= 20)) {
					
					i = abs(pstuff->Fairy.xMove);
					if (i > 512)	i=512;
					if (pstuff->Fairy.xMove > 0) {
						pstuff->Fairy.xMove -= i;
					} else if (pstuff->Fairy.xMove < 0) {
						pstuff->Fairy.xMove += i;
					}
					
					if ((pstuff->Fairy.DropPressed == false) && (pstuff->Fairy.LaunchCount == 0)) {
						i = abs(pstuff->Fairy.yMove);
						if (i > 512)	i=512;
						if (pstuff->Fairy.yMove > 0) {
							pstuff->Fairy.yMove -= i;
						} else if (pstuff->Fairy.yMove < 0) {
							pstuff->Fairy.yMove += i;
						}
					}
					
				}
				
				pstuff->Fairy.fx += pstuff->Fairy.xMove;
				pstuff->Fairy.fy += pstuff->Fairy.yMove;
				
			}
			
			if (pstuff->Fairy.LaunchCount) {
				
				if (pstuff->Fairy.LaunchCount == 1) {
					if (pstuff->FairyMode == 0) {
						if (pstuff->Fairy.Dir > 0) {
							pstuff->Fairy.xMove = (ONE*6) + pstuff->xMove;
						} else {
							pstuff->Fairy.xMove = -(ONE*6) + pstuff->xMove;
						}
					} else {
						if (pstuff->Fairy.Dir > 0) {
							pstuff->Fairy.xMove = (ONE*6);
						} else {
							pstuff->Fairy.xMove = -(ONE*6);
						}
					}
				}
				
				pstuff->Fairy.LaunchCount += 1;
				if (pstuff->Fairy.LaunchCount > 30) pstuff->Fairy.LaunchCount = 0;
				
			}
			
		}
		
		
		// Convert coordinates from fixed point to normal numbers
		pstuff->Fairy.x = pstuff->Fairy.fx / ONE;
		pstuff->Fairy.y = pstuff->Fairy.fy / ONE;
		

		if ((pstuff->Fairy.LaunchCount) || (pstuff->FairyMode)) {
			
			// Character hit detection
			if (pstuff->Fairy.LaunchCount) {
				// When ramming
				if (CharacterHit(pstuff->Fairy.x, pstuff->Fairy.y - 12, pstuff->Fairy.xMove/2, -(ONE*2), 1) >= 0) {
					pstuff->Fairy.xMove -= pstuff->Fairy.xMove*2;
					pstuff->Fairy.fx += pstuff->Fairy.xMove;
					pstuff->Fairy.LaunchCount = 0;
				}
			} else {
				// When not ramming
				if (pstuff->Fairy.HurtCount == 0) {
					c = CharacterHit(pstuff->Fairy.x, pstuff->Fairy.y - 12, 0, 0, 0);
					if (c >= 0) {
						if (pstuff->Fairy.x < (CharacterList_ptr+c)->x) {
							pstuff->Fairy.xMove = -(ONE*2);
						} else {
							pstuff->Fairy.xMove = (ONE*2);
						}
						//PlaySound(SND_MBHURT, -1, 4096, (pstuff->Fairy.x - Camera.x) - ScreenCenterX);
						pstuff->Fairy.HurtCount = 1;
					}
				}
				
			}
			
			// Scan for any entities that were touched
			if (pstuff->Fairy.LaunchCount == 0) {
				for (i=0; i<NumEntities; i+=1) {
					if (Inbox((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, pstuff->Fairy.x - 10, pstuff->Fairy.y - 16, pstuff->Fairy.x + 10, pstuff->Fairy.y + 4)) {
						switch ((EntityList_ptr+i)->Type) {
							case ENT_COIN:
								GiveCoins(pstuff, 1);
								DeleteEntity(i); i-=1;
								break;
						}
					}
				}
			} else {
				for (i=0; i<NumEntities; i+=1) {
					if (Inbox((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, pstuff->Fairy.x - 10, pstuff->Fairy.y - 16, pstuff->Fairy.x + 10, pstuff->Fairy.y - 2)) {
						switch ((EntityList_ptr+i)->Type) {
							case ENT_COIN:
								GiveCoins(pstuff, 1);
								DeleteEntity(i); i-=1;
								break;
						}
					}
				}
			}
			
			// Collision detection (for ramming into things)
			if (pstuff->Fairy.LaunchCount) {
	
				if (pstuff->FairyMode) {
					switch (CollideT(pstuff->Fairy.x, pstuff->Fairy.y, 0, -16, &cy)) {
						#include "solidhits.c"
							pstuff->Fairy.y = cy;
							pstuff->Fairy.fy = ONE * pstuff->Fairy.y;
							if (pstuff->Fairy.yMove < 0) pstuff->Fairy.yMove = 0;
							break;
					}
					
					switch (CollideB(pstuff->Fairy.x, pstuff->Fairy.y, 0, -6, &cy)) {
						#include "solidhits.c"
							pstuff->Fairy.y = cy;
							pstuff->Fairy.fy = ONE * pstuff->Fairy.y;
							if (pstuff->Fairy.yMove > 0) pstuff->Fairy.yMove = 0;
							break;
					}
				}
				
				
				cx = pstuff->Fairy.x / 16;
				cy = pstuff->Fairy.y / 16;
				
				for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
					
					switch(SectorList_ptr[i].hitag) {
						case SEC_HITMODEOVERRIDE:		// Hit mode override
							if (Inbox(cx, cy, SectorList_ptr[i].x1, SectorList_ptr[i].y1, SectorList_ptr[i].x2, SectorList_ptr[i].y2)) {
								HitOverride=SectorList_ptr[i].lotag;
							}
							break;
					}
					
				}
				
				HitBreakable = false;
				for (i=-1; i<=1; i+=1) {
					
					if (pstuff->Fairy.Dir > 0) {
						
						cm = CollideR(pstuff->Fairy.x, pstuff->Fairy.y + (4 * i), 7, -12, &cx);
						if ((cm) && (HitOverride)) cm = HitOverride;
						switch (cm) {
							case HIT_SOLIDBREAK:
								if (pstuff->Fairy.LaunchCount) {
									DestroyTile((pstuff->Fairy.x + 9) / 16, ((pstuff->Fairy.y + (4 * i)) - 12) / 16, false);
									HitBreakable = true;
								}
							case HIT_SPIKES:
							case HIT_SOLID:
							case HIT_DEATH:
								if ((pstuff->Fairy.LaunchCount) && (HitBreakable == false)) {
									PlaySound(SND_HITWALL, -1, 4096, (pstuff->Fairy.x - Camera.x) - ScreenCenterX);
								}
								HitBreakable = true;
								pstuff->Fairy.x = cx;
								pstuff->Fairy.fx = ONE * pstuff->Fairy.x;
								pstuff->Fairy.xMove = -ONE*2;
								pstuff->Fairy.LaunchCount = 0;
								break;
						}
						
					} else {
						
						cm = CollideL(pstuff->Fairy.x, pstuff->Fairy.y + (4 * i), -7, -12, &cx);
						if ((cm) && (HitOverride)) cm = HitOverride;
						switch (cm) {
							case HIT_SOLIDBREAK:
								if (pstuff->Fairy.LaunchCount) {
									DestroyTile((pstuff->Fairy.x - 9) / 16, ((pstuff->Fairy.y + (4 * i)) - 12) / 16, false);
									HitBreakable = true;
								}
							case HIT_SPIKES:
							case HIT_SOLID:
							case HIT_DEATH:
								if ((pstuff->Fairy.LaunchCount) && (HitBreakable == false)) {
									PlaySound(SND_HITWALL, -1, 4096, (pstuff->Fairy.x - Camera.x) - ScreenCenterX);
								}
								HitBreakable = true;
								pstuff->Fairy.x = cx;
								pstuff->Fairy.fx = ONE * pstuff->Fairy.x;
								pstuff->Fairy.xMove = ONE*2;
								pstuff->Fairy.LaunchCount = 0;
								break;
						}
						
					}
					
					if (HitBreakable) break;
					
				}
			}
			
			// Normal collision detection
			if (pstuff->Fairy.LaunchCount == 0) {
				
				for (i=-1;i<=1;i+=1) {
					
					switch (CollideT(pstuff->Fairy.x, pstuff->Fairy.y, (4*i), -17, &cy)) {
						#include "solidhits.c"
							pstuff->Fairy.y = cy;
							pstuff->Fairy.fy = ONE * pstuff->Fairy.y;
							if (pstuff->Fairy.yMove < 0) pstuff->Fairy.yMove = 0;
							pstuff->Fairy.FlutterCount = 0;
							break;
					}
					
					switch (CollideB(pstuff->Fairy.x, pstuff->Fairy.y, (4*i), -3, &cy)) {
						#include "solidhits.c"
							pstuff->Fairy.y = cy;
							pstuff->Fairy.fy = ONE * pstuff->Fairy.y;
							if (pstuff->Fairy.yMove > 0) pstuff->Fairy.yMove = 0;
							pstuff->Fairy.DropPressed = false;
							break;
					}
					
				}
				
				for (i=-1;i<=1;i+=1) {
				
					switch (CollideL(pstuff->Fairy.x, pstuff->Fairy.y, -7, -(10 + (4 * i)), &cx)) {
						#include "solidhits.c"
							pstuff->Fairy.x = cx;
							pstuff->Fairy.fx = ONE * pstuff->Fairy.x;
							if (pstuff->Fairy.xMove < 0) pstuff->Fairy.xMove = 0;
							break;
					}
					
					switch (CollideR(pstuff->Fairy.x, pstuff->Fairy.y, 7, -(10 + (4 * i)), &cx)) {
						#include "solidhits.c"
							pstuff->Fairy.x = cx;
							pstuff->Fairy.fx = ONE * pstuff->Fairy.x;
							if (pstuff->Fairy.xMove > 0) pstuff->Fairy.xMove = 0;
							break;
					}
					
				}
				
			}
			
			// Prevent meibi from escaping the level
			if (pstuff->Fairy.x < 8) {
				pstuff->Fairy.x = 8;
				pstuff->Fairy.fx = ONE*pstuff->Fairy.x;
				pstuff->Fairy.xMove = 0;
				pstuff->Fairy.LaunchCount = 0;
			}
			
			if (pstuff->Fairy.x > (16*LvlHeader_ptr->xdim)-16) {
				pstuff->Fairy.x = (16*LvlHeader_ptr->xdim)-16;
				pstuff->Fairy.fx = ONE*pstuff->Fairy.x;
				pstuff->Fairy.xMove = 0;
				pstuff->Fairy.LaunchCount = 0;
			}
			
			if (pstuff->Fairy.y < 24) {
				pstuff->Fairy.y = 24;
				pstuff->Fairy.fy = ONE*pstuff->Fairy.y;
				pstuff->Fairy.yMove = 0;
			}
			
			if (pstuff->Fairy.y > (16*LvlHeader_ptr->ydim)-16) {
				pstuff->Fairy.y = (16*LvlHeader_ptr->ydim)-16;
				pstuff->Fairy.fy = ONE*pstuff->Fairy.y;
				pstuff->Fairy.yMove = 0;
			}

			
		}
		
	}
	
}
void DoPlayerCollision(PLAYERSTUFF *pstuff) {
	
	int i,a,c,cm,cx,cy;
	int LastYmove=pstuff->yMove;
	int HitOverride=0;
	
	if (pstuff->Death) return;
	
	pstuff->OldOnFloor = pstuff->OnFloor;
	pstuff->OnFloor = false;
	
	// Don't let the player escape the level!
	if (pstuff->x < 8) {
		
		pstuff->x = 8;
		pstuff->fx = ONE * pstuff->x;
		pstuff->xMove = 0;
		
	}
	
	if (pstuff->x >= (16 * (LvlHeader_ptr->xdim - 1)) + 7) {
		
		pstuff->x = (16 * (LvlHeader_ptr->xdim - 1)) + 7;
		pstuff->fx = ONE * pstuff->x;
		pstuff->xMove = 0;
		
	}
	
	// Fall off detection
	if ((pstuff->y > 16 * (LvlHeader_ptr->ydim + 1)) && ((pstuff->y - 24) - Camera.y) > (ScreenYres - 1)) {
		
		PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
		pstuff->Death = true;
		pstuff->FallOff = true;
		pstuff->Health = 0;
		
	}
	
	// Stuck detection
	pstuff->Stuck = false;
	if (pstuff->Look <= 0) {
		
		switch (GetCollideMode(pstuff->x/16, (pstuff->y-17) / 16)) {
			case HIT_SOLID:
				pstuff->Stuck = true;
				break;
		}
		
	}
	
	// Check if player is inside a sector
	cx = pstuff->x/16;
	cy = (pstuff->y-12)/16;
	for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
		
		switch(SectorList_ptr[i].hitag) {
			case SEC_HITMODEOVERRIDE:		// Breakable hit mode override
				if (Inbox(cx, cy, SectorList_ptr[i].x1, SectorList_ptr[i].y1, SectorList_ptr[i].x2, SectorList_ptr[i].y2)) {
					HitOverride=SectorList_ptr[i].lotag;
				}
				break;
		}
		
	}
	
	
	for (c=-1;c<=1;c+=1) {
		
		// Ceiling collision
		if (pstuff->Stuck == false) {
			
			if (pstuff->Look >= 1) {
				cm = CollideT(pstuff->x + ((3 * c)), pstuff->y, 0, -15, &cy);
			} else {
				cm = CollideT(pstuff->x + ((3 * c)), pstuff->y, 0, -21, &cy);
			}
			
			if ((cm) && (HitOverride)) cm = HitOverride;
			
			switch (cm) {
				case HIT_DEATH:
					if (pstuff->Death == false) {
						PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
						pstuff->Death = true;
						pstuff->Health = 0;
					}
					
				case HIT_SPIKES:
					if (pstuff->Dir < 0) {
						HurtPlayer(pstuff, ONE * 1, 1);
					} else {
						HurtPlayer(pstuff, -(ONE * 1), 1);
					}
					
				case HIT_SOLIDBREAK:
					if ((LastYmove < 0) && (cm == HIT_SOLIDBREAK)) DestroyTile((pstuff->x + (3 * c)) / 16, (pstuff->y - 28) / 16, true);
					
				case HIT_SOLID:
					pstuff->y = cy;
					pstuff->fy = ONE * pstuff->y;
					if (pstuff->yMove < 0) pstuff->yMove = -(pstuff->yMove / 2);
					break;
					
			}
			
		}
		
		// Floor collision
		if (pstuff->yMove >= 0) {
			
			cm = CollideB(pstuff->x + ((3 * c)), pstuff->y, 0, 1, &cy);
			if ((cm) && (HitOverride)) cm = HitOverride;
			switch(cm) {
				case HIT_TOPSOLID:	// The first 10 pixels of the tile are solid
					if (((pstuff->y + 1) % 16) <= 10) {
						pstuff->y = cy;
						pstuff->fy = ONE * pstuff->y;
						pstuff->yMove = 0;
						pstuff->OnFloor = true;
					}
					break;
					
				case HIT_DEATH:		// Enables player's 'death' flag regardless of health
					if (pstuff->Death == false) {
						PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
						pstuff->Death = true;
						pstuff->Health = 0;
					}
					
				case HIT_SPIKES:			
					if (pstuff->Dir < 0) {
						HurtPlayer(pstuff, ONE * 1, 1);
					} else {
						HurtPlayer(pstuff, -(ONE * 1), 1);
					}
				
				case HIT_SOLID:		// Completely solid
				case HIT_SOLIDBREAK:
					pstuff->y = cy;
					pstuff->fy = ONE * pstuff->y;
					if (pstuff->yMove >= 0) {
						pstuff->yMove = 0;
						pstuff->OnFloor = true;
					}
					break;
					
			}
			
		}
		
		// Wall/side collision
		if (pstuff->Stuck == false) {
			
			if (pstuff->Look >= 1) {
				cm = CollideL(pstuff->x, pstuff->y, -8, -4, &cx);
			} else {
				cm = CollideL(pstuff->x, pstuff->y, -8, -(4 + (6 * (c + 1))), &cx);
			}
			if ((cm) && (HitOverride)) cm = HitOverride;
			switch (cm) {
				case HIT_DEATH:
					if (pstuff->Death == false) {
						PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
						pstuff->Death = true;
						pstuff->Health = 0;
					}
					
				case HIT_SPIKES:
					if (pstuff->Dir < 0) {
						HurtPlayer(pstuff, ONE * 1, 1);
					} else {
						HurtPlayer(pstuff, -(ONE * 1), 1);
					}
					
				case HIT_SOLIDBREAK:
				case HIT_SOLID:
					pstuff->x = cx;
					pstuff->fx = ONE * pstuff->x;
					if (pstuff->xMove < 0) pstuff->xMove = 0;
					break;
					
			}
			
			if (pstuff->Look >= 1) {
				cm = CollideR(pstuff->x, pstuff->y, 8, -4, &cx);
			} else {
				cm = CollideR(pstuff->x, pstuff->y, 8, -(4 + (6 * (c + 1))), &cx);
			}
			if ((cm) && (HitOverride)) cm = HitOverride;
			switch (cm) {
				case HIT_DEATH:
					if (pstuff->Death == false) {
						PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
						pstuff->Death = true;
						pstuff->Health = 0;
					}
					
				case HIT_SPIKES:
					if (pstuff->Dir < 0) {
						HurtPlayer(pstuff, ONE * 1, 1);
					} else {
						HurtPlayer(pstuff, -(ONE * 1), 1);
					}
					
				case HIT_SOLIDBREAK:
				case HIT_SOLID:
					pstuff->x = cx;
					pstuff->fx = ONE * pstuff->x;
					if (pstuff->xMove > 0) pstuff->xMove = 0;
					break;
					
			}
			
		}
		
	}
	
	if (pstuff->Stuck) {
	
		if (pstuff->Dir < 0) {
			pstuff->fx -= ONE;
		} else {
			pstuff->fx += ONE;
		}
		
	}
	
	
	// Scan for any entity that the player touches
	for (i=0; i<NumEntities; i+=1) {
			
		switch ((EntityList_ptr+i)->Type) {
			case ENT_COIN:
				if (Inbox((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, pstuff->x - 8, pstuff->y - 16, pstuff->x + 8, pstuff->y + 4)) {
					GiveCoins(pstuff, 1);
					DeleteEntity(i); i-=1;
				}
				break;
				
			case ENT_FIREBOW:
				if (Inbox((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, pstuff->x - 8, pstuff->y - 16, pstuff->x + 8, pstuff->y + 4)) {
					if ((pstuff->PowerState != ENT_FIREBOW) || (pstuff->Health < 3)) {
						pstuff->Health = 3;
						pstuff->PowerState = ENT_FIREBOW;
						for (a=0; a<360; a+=60) {
							AddEffect(pstuff->x, pstuff->y-10,
								csin(4096*((float)a/360))*8, ccos(4096*((float)a/360))*4,
								FX_BPARTICLE, NULL, 255, 255, 255);
						}
						PlaySound(SND_POWERUP, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
						DeleteEntity(i); i-=1;
					}
				}
				break;
			
			case ENT_GOALFLAG:
				if (Inbox(pstuff->x, pstuff->y - 6, (EntityList_ptr+i)->x - 5, (EntityList_ptr+i)->y - 40, (EntityList_ptr+i)->x + 5, (EntityList_ptr+i)->y)) {
					pstuff->HitGoal = true;
				}
				break;
				
		}
			
	}
	
	// Scan for any characters that the player touches
	if (pstuff->HurtCount != 1) {
		for (i=0; i<NumCharacters; i+=1) {
			if ((CharacterList_ptr+i)->Dead == false) {
				switch ((CharacterList_ptr+i)->Type) {
					
					// For bad characters
					#include "badchars.c"
						
						// When falling
						if (pstuff->yMove > 0) {
							if (Inbox(pstuff->x, pstuff->y+1, (CharacterList_ptr+i)->x-(CharacterList_ptr+i)->Width, (CharacterList_ptr+i)->y-(CharacterList_ptr+i)->Height, (CharacterList_ptr+i)->x+(CharacterList_ptr+i)->Width,(CharacterList_ptr+i)->y)) {
								(CharacterList_ptr+i)->Health -= 1;
								if (pstuff->JumpPressed) {
									pstuff->yMove = -(ONE*5);
								} else {
									pstuff->yMove = -(ONE*3);
								}
							}
						}
						
						// Contact check
						if (Inbox(pstuff->x, pstuff->y-10, (CharacterList_ptr+i)->x-(CharacterList_ptr+i)->Width, (CharacterList_ptr+i)->y-(CharacterList_ptr+i)->Height, (CharacterList_ptr+i)->x+(CharacterList_ptr+i)->Width, (CharacterList_ptr+i)->y)) {
							if (pstuff->x < (CharacterList_ptr+i)->x) {
								HurtPlayer(pstuff, -ONE, 1);
							} else {
								HurtPlayer(pstuff, ONE, 1);
							}
						}
						
						break;
						
				}
			}
		}
	}
	
	
}
void DrawPlayerSpriteLogic(PLAYERSTUFF *pstuff) {
	
	pstuff->Sprite.x = (pstuff->x - Camera.x) - pstuff->Sprite.mx;
	pstuff->Sprite.y = (pstuff->y - Camera.y) - pstuff->Sprite.my;
	
	if (pstuff->Death == false) {
	
		if (PauseAll != PAUSE_ALL) pstuff->FrameCount = pstuff->FrameCount + abs(pstuff->xMove);
		
		if ((pstuff->FrameCount / ONE) > 15) {
			
			pstuff->Frame = (pstuff->Frame + 1) % 4;
			pstuff->FrameCount = 0;
			
		}
		
		switch (pstuff->PowerState) {
			case ENT_FIREBOW:
				pstuff->Sprite.v = 48;
				break;
			default:
				pstuff->Sprite.v = 0;
				break;
		}
		
		// Facing left
		if (pstuff->Dir < 0) pstuff->Sprite.v += 24;
		pstuff->Sprite.u = 0;
		
		if (pstuff->OnFloor == false) {
			
			if (pstuff->yMove < 0)	pstuff->Sprite.u = 56;
			if (pstuff->yMove > 0)	pstuff->Sprite.u = 70;
			
		} else if (abs(pstuff->xMove) > 127) {
			
			if (pstuff->PowerState == 0) {
				switch (pstuff->Frame) {
					case 0:
						pstuff->Sprite.u = 14;
						break;
					case 1:
					case 3:
						pstuff->Sprite.u = 28;
						break;
					case 2:
						pstuff->Sprite.u = 42;
						break;
				}
			} else {
				switch (pstuff->Frame) {
					case 0:
					case 2:
						pstuff->Sprite.u = 14;
						break;
					case 1:
					case 3:
						pstuff->Sprite.u = 28;
						break;
				}
			}
			
		}
		
		if ((pstuff->Look) && (pstuff->OnFloor)) {
		
			if (pstuff->Look < 0)
				pstuff->Sprite.u = 98;
			else
				pstuff->Sprite.u = 112;
			
		}
		
		if (pstuff->ShootCount)		pstuff->Sprite.u = 42;
		if (pstuff->HurtCount == 1)	pstuff->Sprite.u = 84;
		
		if ((pstuff->ThrowCount >= 1) && (pstuff->ThrowCount <= 10)) {
			pstuff->Sprite.u = 126;
			if (pstuff->Dir > 0) {
				pstuff->Sprite.x -= 1;
			} else {
				pstuff->Sprite.x += 1;
			}
		} else if ((pstuff->ThrowCount >= 11) && (pstuff->ThrowCount <= 20)) {
			pstuff->Sprite.u = 140;
			if (pstuff->Dir > 0) {
				pstuff->Sprite.x += 2;
			} else {
				pstuff->Sprite.x -= 2;
			}
		}
		
		if (pstuff->DoorEntryState) {
			pstuff->Sprite.u = 225;
			pstuff->Sprite.v = 48 * pstuff->PowerState;
		}
		
	} else {
	
		pstuff->Sprite.u = 244;
		pstuff->Sprite.v = 0;
		pstuff->HurtCount = 0;
		
	}

}
void DrawFairySpriteLogic(PLAYERSTUFF *pstuff) {
	
	pstuff->Fairy.Sprite.u = 0;
	pstuff->Fairy.Sprite.v = 192;
	
	if (pstuff->Fairy.Dir < 0) pstuff->Fairy.Sprite.v += 20;
	if (PauseAll != PAUSE_BUTPLAYER) pstuff->Fairy.FrameCount = (pstuff->Fairy.FrameCount + 1) % 10;
	
	if (pstuff->Death) pstuff->Fairy.Sprite.u = 80;
	
	if (pstuff->Fairy.LaunchCount) {
		pstuff->Fairy.Sprite.u = 20;
	} else if (pstuff->Fairy.FlutterCount) {
		pstuff->Fairy.Sprite.u = 100;
	} else if (pstuff->Fairy.DropPressed) {
		pstuff->Fairy.Sprite.u = 120;
	}
	
	if ((pstuff->Fairy.HurtCount >= 1) && (pstuff->Fairy.HurtCount <= 10)) {
		pstuff->Fairy.Sprite.u = 40;
	}
	
	pstuff->Fairy.Sprite.x -= pstuff->Fairy.Sprite.mx;
	pstuff->Fairy.Sprite.y -= pstuff->Fairy.Sprite.my;
	
	#if PLATFORM == PSX
	if (pstuff->Fairy.HurtCount >= 10) {
		if (Flash) GsSortFastSprite(&pstuff->Fairy.Sprite, &myOT[myActiveBuff], 0);
	} else {
		GsSortFastSprite(&pstuff->Fairy.Sprite, &myOT[myActiveBuff], 0);
	}
	#endif
	
	// Draw her wings
	if (pstuff->Fairy.LaunchCount == 0) {
		
		if (pstuff->Fairy.Dir > 0) pstuff->Fairy.Sprite.x += 3;
		pstuff->Fairy.Sprite.y += 10;
		
		pstuff->Fairy.Sprite.u = 0; 
		pstuff->Fairy.Sprite.v = 232 + (6 * (pstuff->Fairy.FrameCount / 5));
		
		if (pstuff->Fairy.FlutterCount) {
			pstuff->Fairy.Sprite.v = 232;
		} else if (pstuff->Fairy.DropPressed) {
			pstuff->Fairy.Sprite.v = 238;
		}
		
		pstuff->Fairy.Sprite.w	= 18;
		pstuff->Fairy.Sprite.h	= 6;
		pstuff->Fairy.Sprite.mx = pstuff->Fairy.Sprite.my = 0;
		
	}
	
}

void CharacterLogic(CHARSTRUCT *CharacterEntry, SPRITE *Sprite, int px, int py, int *Delete, int *Visible) {
	
	int c, cx, cy, a;
	int	Angle, Power;
	
	switch (CharacterEntry->Type) {
		
		case CHAR_NATALIE:
			
			CharacterEntry->Width = 7;
			CharacterEntry->Height = 20;
			
			*Sprite = CharacterSprite[0];
			
			Sprite->w = 14;
			Sprite->h = 20;
			Sprite->mx = 6;
			Sprite->my = 19;
			
			Sprite->x = CharacterEntry->x - Camera.x;
			Sprite->y = CharacterEntry->y - Camera.y;
			
			if (SpriteVisible(*Sprite)) {
				
				if (CharacterEntry->Dead == false) {
				
					// Play death sound once character dies
					if (CharacterEntry->Health < 1) {
						
						PlaySound(SND_NATDIE, -1, 4096, (CharacterEntry->x - Camera.x) - ScreenCenterX);
						
						// Drop coins when killed
						for (a=0; a<10; a+=1) {
							Angle = 4096*(((90*frand())-45) / 360);
							Power = 1+(3*frand());
							AddEntity(CharacterEntry->x, CharacterEntry->y,
								(rsin(Angle)*Power), -(rcos(Angle)*Power), ENT_COIN, 1);
						}
						
						CharacterEntry->Dead = true;
						
					}
					
					if (CharacterEntry->x > px) {
						CharacterEntry->Dir = -1;
					} else {
						CharacterEntry->Dir = 1;
					}
				
				}
				
				if (CharacterEntry->Dead == false) {
					Sprite->u = 0;
				} else {
					Sprite->u = 14;
				}
				
				if (CharacterEntry->Dir <= 0) {
					Sprite->v = 20;
				} else {
					Sprite->v = 0;
				}
				
				
				if (PauseAll == false) {
					CharacterEntry->fx += CharacterEntry->xMove;
					CharacterEntry->fy += CharacterEntry->yMove;
					CharacterEntry->yMove += GRAVITY;
				}
				
				CharacterEntry->x = CharacterEntry->fx / ONE;
				CharacterEntry->y = CharacterEntry->fy / ONE;
				
				
				// Collision detection
				if (CharacterEntry->Dead == false) {
					if (CharacterEntry->yMove > 0) {
						switch (CollideB(CharacterEntry->x, CharacterEntry->y, 0, 1, &cy)) {
							#include "solidhits.c"
								CharacterEntry->y = cy;
								CharacterEntry->fy = ONE * CharacterEntry->y;
								CharacterEntry->yMove = 0;
								break;
						}
					}
				}
				
				Sprite->x = (CharacterEntry->x - Camera.x) - Sprite->mx;
				Sprite->y = (CharacterEntry->y - Camera.y) - Sprite->my;
				
				*Visible = true;
				
			} else {
			
				if (CharacterEntry->Dead) *Delete = true;
				
			}
			break;
			
		case CHAR_MONOHEAD:
			
			CharacterEntry->Width = 9;
			CharacterEntry->Height = 13;
			
			*Sprite = CharacterSprite[0];
			
			Sprite->w = 18;
			Sprite->h = 13;
			Sprite->mx = 8;
			Sprite->my = 12;
			
			Sprite->x = CharacterEntry->x - Camera.x;
			Sprite->y = CharacterEntry->y - Camera.y;
			
			if (SpriteVisible(Sprite[0])) {
				
				if (CharacterEntry->Dir == 0) {
					if (px >= CharacterEntry->x) {
						CharacterEntry->Dir = 1;
					} else {
						CharacterEntry->Dir = -1;
					}
				}
					
				if (CharacterEntry->Dead == false) {
					if (PauseAll == false) {
						
						switch(CharacterEntry->Tag) {
							case 1: // Hopping head
								if (CharacterEntry->OnFloor) {
									if (CharacterEntry->State == 21) CharacterEntry->State = 0;
									if (CharacterEntry->State < 20) CharacterEntry->State += 1;
									if (CharacterEntry->State == 20) {
										CharacterEntry->yMove = -(ONE * 4);
										CharacterEntry->State = 21;
									}
								}
								
								if (CharacterEntry->Dir <= 0) {
									CharacterEntry->fx -= ONE/2;
								} else {
									CharacterEntry->fx += ONE/2;
								}
								
								break;
								
							case 2:
								CharacterEntry->State += 1;
								if (CharacterEntry->State > 359) CharacterEntry->State = 0;
								CharacterEntry->fy -= (csin(11*CharacterEntry->State) / 2);
								if (px >= CharacterEntry->x) {
									CharacterEntry->Dir = 1;
								} else {
									CharacterEntry->Dir = -1;
								}
								break;
								
							default:
								if (CharacterEntry->Dir <= 0) {
									CharacterEntry->fx -= ONE/2;
								} else {
									CharacterEntry->fx += ONE/2;
								}
								break;
								
						}
						
					}
				}
				
				// Sprite drawing and animation
				if (CharacterEntry->Dead == false) {
					if (PauseAll == PAUSE_OFF)	CharacterEntry->Counter += 1;
					switch(CharacterEntry->Tag) {
						case 2:
							if (CharacterEntry->Counter >= 16)	CharacterEntry->Counter = 0;
							Sprite->u = 136+(18*(CharacterEntry->Counter/8));
							break;
							
						default:
							if (CharacterEntry->Counter >= 80)	CharacterEntry->Counter = 0;
				
							if ((((CharacterEntry->Counter/20) >= 0) && (CharacterEntry->Counter/20) <= 2)) {
								Sprite->u = 28+(18*(CharacterEntry->Counter/20));
							} else {
								Sprite->u = 46;
							}
							
							if (CharacterEntry->State == 21) {
								if (CharacterEntry->yMove < 0) Sprite->u = 100; else Sprite->u = 118;
							}
							break;
					}
					
				} else {
					Sprite->u = 82;
				}
				
				if (CharacterEntry->Dir <= 0) {
					Sprite->v = 0;
				} else {
					Sprite->v = 13;
				}
				
				Sprite->x = (CharacterEntry->x - Camera.x) - Sprite->mx;
				Sprite->y = (CharacterEntry->y - Camera.y) - Sprite->my;
				
				*Visible = true;
				
			} else {
				
				if (CharacterEntry->Dead) *Delete=true;
				
			}
			
			if (CharacterEntry->Dead == false) {
				if (CharacterEntry->Health <= 0) {
					PlaySound(SND_NATDIE, -1, 4096, (CharacterEntry->x - Camera.x) - ScreenCenterX);
					CharacterEntry->Dead = true;
					CharacterEntry->Tag = 0;
				}
			}
			
			if (PauseAll == PAUSE_OFF) {
				
				switch(CharacterEntry->Tag ) {
					case 2: // Flying monohead
						break;
					default:
						CharacterEntry->yMove += GRAVITY;
						if (CharacterEntry->yMove > (ONE*FALL_LIMIT)) CharacterEntry->yMove = ONE*FALL_LIMIT;
						break;
				}
				
				CharacterEntry->fx += CharacterEntry->xMove;
				CharacterEntry->fy += CharacterEntry->yMove;
				
			}
			
			CharacterEntry->x = CharacterEntry->fx/ONE;
			CharacterEntry->y = CharacterEntry->fy/ONE;
			
			// Collision detection
			if (CharacterEntry->Dead == false) {
				
				// Ceiling contact
				switch (CollideT(CharacterEntry->x, CharacterEntry->y, 0, -13, &cy)) {
					#include "solidhits.c"
						CharacterEntry->y = cy;
						CharacterEntry->fy = ONE*CharacterEntry->y;
						CharacterEntry->yMove = ONE;
						break;
				}
				
				// Floor contact
				CharacterEntry->OnFloor = false;
				switch (CollideB(CharacterEntry->x, CharacterEntry->y, 0, 1, &cy)) {
					#include "solidhits.c"
						CharacterEntry->y = cy;
						CharacterEntry->fy = ONE*CharacterEntry->y;
						CharacterEntry->yMove = 0;
						CharacterEntry->OnFloor = true;
						break;
				}
				
				if (Visible) {
					
					// Changing direction
					if (CharacterEntry->Dir <= 0) {
						switch (CollideL(CharacterEntry->x, CharacterEntry->y, -10, 0, &cx)) {
							#include "solidhits.c"
								CharacterEntry->x = cx;
								CharacterEntry->xMove = 0;
								CharacterEntry->fx = ONE*CharacterEntry->x;
								CharacterEntry->Dir = 1;
						}
					} else {
						switch (CollideR(CharacterEntry->x, CharacterEntry->y, 10, 0, &cx)) {
							#include "solidhits.c"
								CharacterEntry->x = cx;
								CharacterEntry->xMove = 0;
								CharacterEntry->fx = ONE*CharacterEntry->x;
								CharacterEntry->Dir = -1;
						}
					}
				}
				
				// Delete character if it feel off the level
				if (CharacterEntry->y > (16 * (LvlHeader_ptr->ydim+1))) *Delete = true;
				
			}
			
	}
	
}
void ProjectileLogic(PROJSTRUCT *ProjectileEntry, SPRITE *Sprite, int *Delete) {
	
	int	a,ci;
	int	c,cx,cy;
	
	switch (ProjectileEntry->Type) {
		case PROJ_FIREBALL:
		
			Sprite->w = 8;
			Sprite->h = 8;
			Sprite->mx = 4;
			Sprite->my = 4;
			
			Sprite->x = (ProjectileEntry->x - Camera.x);
			Sprite->y = (ProjectileEntry->y - Camera.y);

			if (SpriteVisible(*Sprite)) {
				
				if (PauseAll == false) {
					ProjectileEntry->fx += ProjectileEntry->xMove;
					ProjectileEntry->fy += ProjectileEntry->yMove;
				}
				
				ProjectileEntry->x = ProjectileEntry->fx / ONE;
				ProjectileEntry->y = ProjectileEntry->fy / ONE;
				
				// Collision detection
				if (CollideB(ProjectileEntry->x, ProjectileEntry->y, 0, 4, &cy)) {
					ProjectileEntry->y = cy;
					ProjectileEntry->yMove = -(2 * ONE);
				}
				
				c  = GetCollideMode((ProjectileEntry->x - 4) / 16, ProjectileEntry->y / 16);
				c |= GetCollideMode((ProjectileEntry->x + 4) / 16, ProjectileEntry->y / 16);
				switch (c) {
					#include "solidhits.c"
						for (a=0; a<360; a+=90) {
							AddEffect(ProjectileEntry->x, ProjectileEntry->y,
								rsin(4096*((float)a/360))*4, rcos(4096*((float)a/360))*2,
								FX_BPARTICLE, 0, 255, 191, 0);
						}
						PlaySound(SND_FIREHIT, -1, 4096, (ProjectileEntry->x - Camera.x) - ScreenCenterX);
						*Delete = true;
						break;
				}
				
				// Character hit detection
				c = CharacterHit(ProjectileEntry->x, ProjectileEntry->y, ProjectileEntry->xMove/2, -(ONE*2), 5);
				if (c>=0) {
					for (a=0; a<360; a+=90) {
						AddEffect(ProjectileEntry->x, ProjectileEntry->y,
							rsin(4096*((float)a/360))*4, rcos(4096*((float)a/360))*2,
							FX_BPARTICLE, 0, 255, 191, 0);
					}
					PlaySound(SND_FIREHIT, -1, 4096, (ProjectileEntry->x - Camera.x) - ScreenCenterX);
					AddEntity((CharacterList_ptr+c)->x, (CharacterList_ptr+c)->y, 0, -(ONE*3), ENT_COIN, 1);
					*Delete=true;
				}
				
				// Make the projectile fall
				if (PauseAll == PAUSE_OFF) {
					ProjectileEntry->yMove += GRAVITY;
					if (ProjectileEntry->yMove > ONE * FALL_LIMIT) ProjectileEntry->yMove = ONE * FALL_LIMIT;
				}
				
				Sprite->x = (ProjectileEntry->x - Camera.x) - Sprite->mx;
				Sprite->y = (ProjectileEntry->y - Camera.y) - Sprite->my;
				
				Sprite->u = 0 + (8 * (ProjectileEntry->Count / 2));
				Sprite->v = 10;
				
				if (ProjectileEntry->Count == 0) {
					AddEffect(ProjectileEntry->x, ProjectileEntry->y,
						ProjectileEntry->xMove, ProjectileEntry->yMove,
						FX_BPARTICLE, 0, 255, 191, 0);
				}
				
				if (PauseAll == false) {
					if (ProjectileEntry->xMove < 0) {
						ProjectileEntry->Count = ((ProjectileEntry->Count + 1) % 8);
					} else {
						ProjectileEntry->Count -= 1;
						if (ProjectileEntry->Count < 0) ProjectileEntry->Count = 7;
					}
				}
				
			} else {
				*Delete = true;
			}
			break;
	}
	
}

void GiveCoins(PLAYERSTUFF *pstuff, int coins) {
	
	if (pstuff->FairyMode == 0) {
		PlaySound(SND_GETCOIN, -1, 4096 + (128 * (coins - 1)), (pstuff->x - Camera.x) - ScreenCenterX);
	} else {
		PlaySound(SND_GETCOIN, -1, 4096 + (128 * (coins - 1)), (pstuff->Fairy.x - Camera.x) - ScreenCenterX);
	}
	
	PlayerStats.CoinCount	+= coins;
	pstuff->HealthCoinCount += coins;
	if (pstuff->Health == 3) pstuff->HealthCoinCount = 0;
	
	if (PlayerStats.CoinCount >= 100) {	// If player gets 100 coins, give him an extra life
		if (pstuff->FairyMode == 0) {
			PlaySound(SND_ONEUP, -1, 4096, 0);
		} else {
			PlaySound(SND_ONEUP, -1, 4096, 0);
		}
		PlayerStats.CoinCount -= 100;
		pstuff->Lives += 1;
		
		if (pstuff->HealthCoinCount >= 20) {
			if (pstuff->Health < 3) pstuff->Health += 1;
			pstuff->HealthCoinCount -= 20;
		}
		
	} else {
		
		if (pstuff->HealthCoinCount >= 20) {
			if (pstuff->Health < 3) pstuff->Health += 1;
			PlaySound(SND_POWERUP, -1, 4096, 0);
			pstuff->HealthCoinCount -= 20;
		}
		
	}
	
}
void HurtPlayer(PLAYERSTUFF *pstuff, int xMove, int damage) {
	
	if ((pstuff->HurtCount == 0) && (pstuff->Death == false)) {
		
		PlaySound(SND_HURT, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
		
		if ((pstuff->PowerState) && (pstuff->Health == 1)) {
			PlaySound(SND_POWERDOWN, -1, 4096, (pstuff->x - Camera.x) - ScreenCenterX);
			pstuff->PowerState = 0;
		} else {
			pstuff->Health -= damage;
			if (pstuff->Health <= 0)	pstuff->Death = true;
		}
		
		if (pstuff->Death == false) {
			pstuff->HurtCount = 1;
			pstuff->OnFloor = false;
			
			pstuff->xMove = xMove;
			pstuff->yMove = -(ONE * 2);
			pstuff->fy -= ONE;
		}
		
	}
	
}

// Dialog system functions
int GetScriptEntry(char *SearchEntry, char *Output) {
	
	char *CharPos_ptr = ScriptCharBase_ptr;
	
	while(1) {
		
		// Check if the line contains the entry we need
		if (strncmp(CharPos_ptr, SearchEntry, strlen(SearchEntry)) == 0) {
			strcpy(Output, CharPos_ptr+strlen(SearchEntry));
			return(1);
		}
		
		// Skip the line
		while(*CharPos_ptr != 0x00) {
			if (*CharPos_ptr == 0x1a) return(0);
			CharPos_ptr++;
		}
		while(*CharPos_ptr == 0x00) {
			if (*CharPos_ptr == 0x1a) return(0);
			CharPos_ptr++;
		}
		if (*CharPos_ptr == 0x1a) return(0);
		
	}
	
}
char *GetScriptEntryPos(char *SearchEntry) {
	
	char *CharPos_ptr = ScriptCharBase_ptr;
	
	while(1) {
		
		// Check if the line contains the entry we need
		if (strncmp(CharPos_ptr, SearchEntry, strlen(SearchEntry)) == 0) {
			return(CharPos_ptr);	// Return its pointer
		}
		
		// Skip the line
		while(*CharPos_ptr != 0x00) {
			if (*CharPos_ptr == 0x1a) return(0);
			CharPos_ptr++;
		}
		while(*CharPos_ptr == 0x00) {
			if (*CharPos_ptr == 0x1a) return(0);
			CharPos_ptr++;
		}
		if (*CharPos_ptr == 0x1a) return(0);
		
	}
	
}
char *NextLine(char *CharPos_ptr) {

	// Skip the line
	while(*CharPos_ptr != 0x00) {
		if (*CharPos_ptr == 0x1a) return(0);
		CharPos_ptr++;
	}
	while(*CharPos_ptr == 0x00) {
		if (*CharPos_ptr == 0x1a) return(0);
		CharPos_ptr++;
	}
	if (*CharPos_ptr == 0x1a) return(0);
	
	return(CharPos_ptr);
	
}
void StartDialog(int DialogNum) {
	
	DialogState = 0;
	DialogCount = 0;
	DialogLine = 0;
	DialogMode = 1;
	
	FlushDialog();
	
	sprintf(StringTemp, "#DIALOG=%d", DialogNum);
	
	ScriptChar_ptr = GetScriptEntryPos(StringTemp);
	ScriptChar_ptr = NextLine(ScriptChar_ptr);
	if (ScriptChar_ptr == 0) return;
	
	DialogState = 1;
	DialogFull = false;
	
}
void FlushDialog() {
	
	*DialogBuff_ptr[0] = 0;
	*DialogBuff_ptr[1] = 0;
	*DialogBuff_ptr[2] = 0;
	*DialogBuff_ptr[3] = 0;
	DialogLine = 0;
	DialogCount = 0;
	DialogFull = false;
	
}
void ScrollDialogUp() {
	
	int i;
	char *Temp;
	
	Temp = DialogBuff_ptr[0];
	for (i=0; i<3; i++) {
		DialogBuff_ptr[i] = DialogBuff_ptr[i+1];
	}
	DialogBuff_ptr[3] = Temp;
	
	*DialogBuff_ptr[3] = 0;
	
}
void DoDialog(int next) {
	
	static short NextPressed=0;
	
	// Do dialog box
	if (DialogState) {
		
		if (DialogState == 1) {
			
			if (DialogTyping == false) {
				
				if (*ScriptChar_ptr == '#') {
					if (strcmp(ScriptChar_ptr, "#TELETYPE=ON") == 0) DialogMode = 1;
					if (strcmp(ScriptChar_ptr, "#TELETYPE=OFF") == 0) DialogMode = 0;
					if (strcmp(ScriptChar_ptr, "#FLUSH") == 0) FlushDialog();
					if (strcmp(ScriptChar_ptr, "#PAUSE") == 0) DialogState = 2;
					if (strcmp(ScriptChar_ptr, "#END") == 0) DialogState = 3;
					ScriptChar_ptr = NextLine(ScriptChar_ptr);
				} else {
					if (DialogFull) ScrollDialogUp();
					DialogTyping = true;
				}
				
			} else {
				
				if (DialogMode == 1) {
					
					if ((Flash) || (PlayerInput[0].jump)) {
					
						strncat(DialogBuff_ptr[DialogLine], ScriptChar_ptr, 1);
						ScriptChar_ptr++;
						
						if  (*ScriptChar_ptr != 32) {
							if ((DialogCount % 2) == 0) PlaySound(SND_CHOOSE, -1, 4096, 0);
							DialogCount += 1;
						}
						
						if (*ScriptChar_ptr == 0x00) {
							ScriptChar_ptr = NextLine(ScriptChar_ptr);
							if (DialogLine < 3) DialogLine += 1; else DialogFull = true;
							DialogTyping = false;
						}
						
					}
					
					// Fast forward teletype
					if (PlayerInput[0].pause) {
						
						while(1) {
							
							strncat(DialogBuff_ptr[DialogLine], ScriptChar_ptr, 1);
							ScriptChar_ptr++;
							
							if (*ScriptChar_ptr != 32) DialogCount += 1;
							
							if (*ScriptChar_ptr == 0x00) {
								ScriptChar_ptr = NextLine(ScriptChar_ptr);
								if (DialogLine < 3) DialogLine += 1; else DialogFull = true;
								break;
							}
							
						}

						while(ScriptChar_ptr[0] != '#') {
							if (DialogFull) ScrollDialogUp();
							strcpy(DialogBuff_ptr[DialogLine], ScriptChar_ptr);
							ScriptChar_ptr = NextLine(ScriptChar_ptr);
							if (DialogLine < 3) DialogLine += 1; else DialogFull = true;
						}
						DialogTyping = false;
					}
					
					
				} else {
					
					while(ScriptChar_ptr[0] != '#') {
						strcpy(DialogBuff_ptr[DialogLine], ScriptChar_ptr);
						ScriptChar_ptr = NextLine(ScriptChar_ptr);
						if (DialogLine < 3) DialogLine += 1; else DialogFull = true;
					}
					DialogTyping = false;
					
				}
				
			}
			
		}
		
		DrawText(DialogBuff_ptr[0], CenterPosX + 40, 50, 0, 127, 127, 127);
		DrawText(DialogBuff_ptr[1], CenterPosX + 40, 59, 0, 127, 127, 127);
		DrawText(DialogBuff_ptr[2], CenterPosX + 40, 68, 0, 127, 127, 127);
		DrawText(DialogBuff_ptr[3], CenterPosX + 40, 77, 0, 127, 127, 127);
		
		if (DialogState != 1) DrawUiCell(CenterPosX + 156, 84 + Bobbing, 5, 1, 8, 8, 0, 127, 127, 127);
		
		DrawMenuPanel(CenterPosX + 28, 40, CenterPosX + 292, 94, true);
		
	}
	
	if (next) {
		if (NextPressed == false) {
			if (DialogState == 3) DialogState = 0;
			if (DialogState == 2) DialogState = 1;
		}
		NextPressed = true;
	} else {
		NextPressed = false;
	}
	
}

int CharacterHit(int x, int y, int xMove, int yMove, int Damage) {

	//	Returns the index of the character that x and y are in... -1 if none.
	
	int i;
	
	for (i=0; i<NumCharacters; i+=1) {
		if ((CharacterList_ptr+i)->Dead == false) {
			
			if (Inbox(x, y, (CharacterList_ptr+i)->x - (CharacterList_ptr+i)->Width, (CharacterList_ptr+i)->y-(CharacterList_ptr+i)->Height, (CharacterList_ptr+i)->x+(CharacterList_ptr+i)->Width, (CharacterList_ptr+i)->y)) {
				
				switch ((CharacterList_ptr+i)->Type) {
					
					// Enemy characters
					#include "badchars.c"
						
						if (Damage) {
							(CharacterList_ptr+i)->Health -= Damage;
							if ((CharacterList_ptr+i)->Health <= 0) {
								(CharacterList_ptr+i)->xMove = xMove;
								(CharacterList_ptr+i)->yMove = yMove; 
							}
						}
						
						return(i);
						
				}
				
			}
			
		}
	}
	return(-1);
	
}
void DestroyTile(short tx, short ty, int frombelow) {
	
	int i;
	int TileNum,ttx,tty;
	GsSPRITE TempSprite;
	
	if (*(LvlData_ptr+(tx+(LvlHeader_ptr->xdim*ty))) == 0)	return;
	
	TileNum = *(LvlData_ptr+(tx+(LvlHeader_ptr->xdim*ty))) - 1;
	*(LvlData_ptr+(tx+(LvlHeader_ptr->xdim*ty))) = 0;
	
	
	TempSprite = *(FGtileSprite_ptr+TileNum);
	ttx = (16 * tx) + 4;
	tty = (16 * ty) + 4;
	
	// Upper-left piece
	TempSprite.mx = TempSprite.my = 4;
	TempSprite.w = TempSprite.h = 8;
	AddEffect(ttx, tty, -(2*ONE), -(3*ONE), FX_SPRITEBIT, &TempSprite, 128, 128, 128);
	
	// Upper-right piece
	TempSprite.u += 8;
	AddEffect(ttx+8, tty, (2*ONE), -(3*ONE), FX_SPRITEBIT, &TempSprite, 128, 128, 128);
	
	// Lower-left piece
	TempSprite.u -= 8;
	TempSprite.v += 8;
	AddEffect(ttx, tty+8, -(1*ONE), -(2*ONE), FX_SPRITEBIT, &TempSprite, 128, 128, 128);
	
	// Lower-right piece
	TempSprite.u += 8;
	AddEffect(ttx+8, tty+8, (1*ONE), -(2*ONE), FX_SPRITEBIT, &TempSprite, 128, 128, 128);
	
	
	
	if (frombelow) {
		
		// Scan for any entities that lie above it
		ttx = 16 * tx;
		tty = 16 * (ty - 1);
		for (i=0; i<NumEntities; i+=1) {
			switch (EntityList_ptr[i].Type) {
				case ENT_COIN:
					if (Inbox(EntityList_ptr[i].x, EntityList_ptr[i].y, ttx, tty, ttx+16, tty+16)) {
						EntityList_ptr[i].yMove = -(ONE*2);
						EntityList_ptr[i].Flag = 1;
					}
					break;
			}
		}
		
		// Scan for any characters that lie above it
		for (i=0; i<NumCharacters; i+=1) {
			switch ((CharacterList_ptr+i)->Type) {
				#include "badchars.c"
					if (Inbox((CharacterList_ptr+i)->x, (CharacterList_ptr+i)->y, ttx, tty, ttx+16, tty+16)) {
						(CharacterList_ptr+i)->yMove = -(ONE*3);
						(CharacterList_ptr+i)->Health -= 2;
					}
					break;
			}
		}
		
	}
	
	// Play tile destroyed sound
	PlaySound(SND_ROCKSMASH, -1, 4096, (ttx - Camera.x) - ScreenCenterX);
	
}