int GameLoop() {
	
	// For the level completed sequence
	int		WinCount=0;
	GsBOXF	box = {0};
	int		BoxExpand=0;
	int		BoxExpandSpeed=0;
	
	
	// For the pause menu
	short	PauseState=0;
	short	UpPressed=0,DownPressed=0,MenuSel=0,MenuPage=0,MenuAccept=0;
	short	Back=0,BackPressed=0;
	
	int		SelPressed=0;
	
	int		i,cx,cy;
	int		bx1,by1,bx2,by2;
	
	char	LevelName[32]={0};
	
	
	// For the dialog system
	char	DialogBuff[4][48]={0};
	char	ScriptLineBuff[48]={0};
	
	
	// For storing the level data
	u_char	LvlData[q2sector(LvlHeader_ptr->xdim*LvlHeader_ptr->ydim)];
	
	
	// Prime the pointers
	LvlData_ptr = LvlData;
	
	DialogBuff_ptr[0]	= &DialogBuff[0][0];
	DialogBuff_ptr[1]	= &DialogBuff[1][0];
	DialogBuff_ptr[2]	= &DialogBuff[2][0];
	DialogBuff_ptr[3]	= &DialogBuff[3][0];
	
	
	// Load the entire level data (assuming that the last read was the level header)
	PckReadFile(0, 0, (u_long*)&LvlData, q2sector(LvlHeader_ptr->xdim*LvlHeader_ptr->ydim));
	CdReadSync(0, 0);
	
	
	// Play XA track (if set)
	if (LvlHeader_ptr->TrackNum) {
		XAsetup(2);
		XAplayChannel(&XAfiles[0], LvlHeader_ptr->TrackNum - 1, true);
	}
	
	
	// Search for the level title in the script
	if (LvlHeader_ptr->TxtData_ptr) {
		if (GetScriptEntry("#TITLE=", LevelName)) {
			#if DEBUG
			printf("Level name: %s\n", LevelName);
			#endif
		}
		
		/*
		if (GetScriptEntry("#AUTHOR=", LevelAuthor)) {
			printf("Author: %s\n", LevelAuthor);
		}
		if (GetScriptEntry("#GFX=", LevelGfx)) {
			printf("Graphics: %s\n", LevelGfx);
		}
		*/
	}
	
	
	retry:
	
	
	// Set player position to starting point
	Player[0].x = StartPos.x;
	Player[0].y = StartPos.y;
	Player[0].Dir = StartPos.dir;
	Player[0].fx = ONE * Player[0].x;
	Player[0].fy = ONE * Player[0].y;
	Player[0].xMove = 0;
	Player[0].yMove = 0;
	
	Player[0].PowerState = 0;
	Player[0].Health = 3;
	Player[0].HitGoal = 0;
	
	Player[0].Death = false;
	Player[0].FallOff = false;
	Player[0].DeadCount = 0;
	Player[0].HurtCount = 0;
	Player[0].DoneFor = false;
	Player[0].HealthCoinCount = 0;
	
	FixStuff();
	
	TransitionIn();
	
	
	while(1) {
		
		PrepDisplay();
		DoTransitions();
		PauseAll = PAUSE_OFF;
		
		if (DialogState) PauseAll = PAUSE_ALL;
		if ((Player[0].HitGoal) || (Player[1].HitGoal)) PauseAll = PAUSE_ALL;
		if ((Player[0].DoorEntryState) || (Player[1].DoorEntryState)) PauseAll = PAUSE_ALL;
		
		
		// Get controller input
		if (MenuAccept == 0) {
			GetInput();
		} else {
			PlayerInput[0] = BlankPlayerInput;
			PlayerInput[1] = BlankPlayerInput;
		}
		
		
		if (PlayerInput[0].select) {
			if (SelPressed == false) {
				if (AspectMode == 0) {
					Set16x9();
				} else {
					Set4x3();
				}
			}
			SelPressed = true;
		} else {
			SelPressed = false;
		}
		
		
		// Win game animation
		if ((Player[0].HitGoal) || (Player[1].HitGoal)) {
			
			box.r = box.g = box.b = 255;
			
			box.y = ScreenCenterY-((BoxExpand/ONE)/2);
			box.h = (BoxExpand/ONE);
			box.x = 0;
			box.w = ScreenXres;
			
			GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
			
			box.y = 0;
			box.h = ScreenYres;
			box.x = ScreenCenterX-((BoxExpand/ONE)/2);
			box.w = (BoxExpand/ONE);
			
			GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
			
			BoxExpandSpeed += 1280;
			BoxExpand += BoxExpandSpeed;
			if (BoxExpand > (ONE * ScreenYres)) BoxExpand = (ONE * ScreenYres);
			
			WinCount += 1;
			if (WinCount >= 60) goto wingame;
			
		}
		
		
		// Toggle pausing
		if ((Player[0].Death == 0) && (TransOnGoing == false) && (WinCount == 0) && (DialogState == 0)) {
			if (PlayerInput[0].tap_pause) {
				if (ScreenAdjustMode == 0) {
					if (PauseState == 0) {
						PlaySound(SND_SELECT, -1, ONE, 0);
						MenuSel=0; MenuPage=0; MenuAccept=0;
					} else {
						PlaySound(SND_RETURN, -1, ONE, 0);
					}
					PauseState = (PauseState + 1) % 2;
				}
			}
		}
		
		// Pause menu
		if (PauseState) {
			
			PauseAll = PAUSE_ALL;
			
			Back = false;
			if ((PlayerInput[0].throw) || (PlayerInput[0].run)) {
				if (BackPressed == false) {
					if (PlayerInput[0].throw) Player[0].ThrowPressed = true;
					Back = true;
				}
				BackPressed = true;
			} else {
				BackPressed = false;
			}
			
			StringTemp[0] = 0;
			switch(MenuPage) {
				case 0: // Pause menu
					
					if (PlayerInput[0].tap_up | PlayerInput[1].tap_up) {
						PlaySound(SND_CHOOSE, -1, ONE, 0);
						MenuSel -= 1;
					}
					
					if (PlayerInput[0].tap_down | PlayerInput[1].tap_down) {
						PlaySound(SND_CHOOSE, -1, ONE, 0);
						MenuSel += 1;
					}
					
					if (MenuSel < 0) MenuSel = 3;
					if (MenuSel > 3) MenuSel = 0;
					
					DrawText("Pause", CENTERED, ScreenCenterY - 35, 0, 128, 128, 128);
					if (LevelName[0] != 0) DrawText(LevelName, CENTERED, 170, 0, 128, 128, 128);
					
					DrawUiCell((ScreenCenterX-49)-Bobbing, (ScreenCenterY-19)+(10*MenuSel), 5, 3, 8, 8, 0, 128, 128, 128);
					DrawUiCell((ScreenCenterX+42)+Bobbing, (ScreenCenterY-19)+(10*MenuSel), 5, 2, 8, 8, 0, 128, 128, 128);
					
					DrawText("Resume Game", CENTERED, ScreenCenterY - 19, 0, 128, 128, 128);
					DrawText("Restart Level", CENTERED, ScreenCenterY - 9, 0, 128, 128, 128);
					DrawText("Options", CENTERED, ScreenCenterY + 1, 0, 128, 128, 128);
					DrawText("Quit Game", CENTERED, ScreenCenterY + 11, 0, 128, 128, 128);
					
					DrawMenuPanel(ScreenCenterX - 60, ScreenCenterY - 30, ScreenCenterX + 60, ScreenCenterY + 30, false);
					
					CharTemp[0] = CHR_UP;		strcat(StringTemp, CharTemp);
					CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
					CharTemp[0] = CHR_DOWN;		strcat(StringTemp, CharTemp);
					strcat(StringTemp, "-Select ");
					
					CharTemp[0] = CHR_CROSS;	strcat(StringTemp, CharTemp);
					strcat(StringTemp, "-Accept ");
					
					CharTemp[0] = CHR_CIRCLE;	strcat(StringTemp, CharTemp);
					CharTemp[0] = '/';			strcat(StringTemp, CharTemp);
					CharTemp[0] = CHR_SQUARE;	strcat(StringTemp, CharTemp);
					strcat(StringTemp, "-Back ");
					
					if (PlayerInput[0].tap_jump | PlayerInput[1].tap_jump) {
						PlaySound(SND_SELECT, -1, ONE, 0);
						switch(MenuSel) {
							case 0:
								Player[0].JumpPressed = true;
								PauseState = 0;
								break;
							case 1:
								MenuAccept = 1;
								TransitionOut();
								break;
							case 2:
								MenuSel = 0;
								MenuPage = 1;
								break;
							case 3:
								MenuAccept = 2;
								TransitionOut();
								break;
						}
					}
					
					if (Back) {
						PlaySound(SND_RETURN, -1, ONE, 0);
						PauseState = 0;
					}
					
					break;
					
				case 1: // Options menu
					
					DoOptionsStuff(&MenuSel, &PlayerInput[0]);
					
					if (Back) {
						if (ScreenAdjustMode == false) {
							PlaySound(SND_RETURN, -1, ONE, 0);
							MenuPage = 0;
							MenuSel = 0;
						} else {
							ScreenAdjustMode=0;
						}
					}
					
			}
			
			DrawText(StringTemp, CENTERED, ScreenYres - 24, 0, 128, 128, 128);
			
			
			box.x = box.y = 0;
			box.w = ScreenXres;
			box.h = ScreenYres;
			box.r = box.g = box.b = 64;
			box.attribute = (2<<28)|(1<<30);
			GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
			box.attribute = 0;
			
		}
		
		
		
		DoPlayerLogic(&Player[0], &PlayerInput[0]);
		if (LvlHeader_ptr->Flags.NoFairy == false) DoFairyLogic(&Player[0], &PlayerInput[0]);
		
		
		if (Player[0].Death) {
			PauseAll = PAUSE_BUTPLAYER;
			if (Player[0].DoneFor) {
				if (TransCount == 0) TransitionOut();
				if (TransOnGoing == false) {
					if (Player[0].Lives == 0) goto losegame;
					Player[0].Lives -= 1;
					goto retry;
				}
			}
		}
		
		
		// Camera stuff
		if (PauseAll == PAUSE_OFF) {
			
			cx = Player[0].x;
			cy = Player[0].y;
			
			bx1 = 0;
			by1 = 0;
			bx2 = LvlHeader_ptr->xdim;
			by2 = LvlHeader_ptr->ydim;
			
			// Check if player is in a camera lock sector
			for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
				if (SectorList_ptr[i].hitag == SEC_CAMERALOCK) {
					if (Inbox(cx/16, cy/16, SectorList_ptr[i].x1, SectorList_ptr[i].y1, SectorList_ptr[i].x2, SectorList_ptr[i].y2)) {
						bx1 = SectorList_ptr[i].x1;
						by1 = SectorList_ptr[i].y1;
						bx2 = SectorList_ptr[i].x2 + 1;
						by2 = SectorList_ptr[i].y2 + 1;
						break;
					}
				}
			}
			
			Camera.dx = cx - ScreenCenterX;
			if (Player[0].Look <= -120) {
				Camera.dy = (cy - 110) - ScreenCenterY;
			} else if (Player[0].Look >= 120) {
				Camera.dy = (cy + 90) - ScreenCenterY;
			} else {
				Camera.dy = (cy - 10) - ScreenCenterY;
			}
			
			if ((bx2 - bx1) >= (ScreenXres / 16)) {
				if (Camera.dx > (16 * bx2) - (ScreenXres - 1))
					Camera.dx = (16 * bx2) - (ScreenXres - 1);
				if (Camera.dx < (16 * bx1))
					Camera.dx = 16 * bx1;
			} else {
				Camera.dx = -ScreenCenterX + ((((16 * ((bx2 - bx1) + 1)) / 2) - 8) + (16 * bx1));
			}
			
			if ((by2 - by1) >= (ScreenYres / 16)) {
				if (Camera.dy > (16 * by2) - (ScreenYres - 1))
					Camera.dy = (16 * by2) - (ScreenYres - 1);
				if (Camera.dy < (16 * by1))
					Camera.dy = 16 * by1;
			} else {
				Camera.dy = -ScreenCenterY + ((((16 * ((by2 - by1) + 1)) / 2) - 8) + (16 * by1));
			}
			
			Camera.dx = ONE * Camera.dx;
			Camera.dy = ONE * Camera.dy;
			Camera.fx = Camera.fx + ((Camera.dx - Camera.fx) / 10);
			Camera.fy = Camera.fy + ((Camera.dy - Camera.fy) / 10);
			
			Camera.x = Camera.fx / ONE;
			Camera.y = Camera.fy / ONE;
			
		}
		
		
		// Marilyn (174,24)(14x14)
		Player[0].Sprite.x = CenterPosX + 8;
		Player[0].Sprite.y = 15;
		Player[0].Sprite.w = Player[0].Sprite.h = 14;
		Player[0].Sprite.mx = Player[0].Sprite.my = 0;
		Player[0].Sprite.u = 242;
		Player[0].Sprite.v = 24 + (14 * Player[0].Death);
		GsSortFastSprite(&Player[0].Sprite, &myOT[myActiveBuff], 0);
		
		DrawUiCell(CenterPosX + 22, 22, 4, 7, 7, 7, 0, 128, 128, 128);
		for (i=0; i<3; i+=1) {
			if (i < Player[0].Health) {
				DrawUiCell(CenterPosX + (8 + (8 * i)), 30, 5, 7 , 8, 7, 0, 128, 128, 128);
			} else {
				DrawUiCell(CenterPosX + (8 + (8 * i)), 30, 5, 8 , 8, 7, 0, 128, 128, 128);
			}
		}
		
		sprintf(StringTemp, "%d", Player[0].Lives);
		DrawText(StringTemp, CenterPosX + 30, 21, 0, 128, 128, 128);
		
		
		// Key counter
		if (PlayerStats.KeyCount) {
			DrawUiCell(CenterPosX + 254, 19, 4, 9, 7, 8, 0, 128, 128, 128);
			DrawUiCell(CenterPosX + 262, 20, 4, 7, 7, 7, 0, 128, 128, 128);
			sprintf(StringTemp, "0");
			DrawText(StringTemp, CenterPosX + 270, 19, 0, 128, 128, 128);
		}
		
		// Coin counter
		DrawUiCell(CenterPosX + 283, 19, 4, 8, 8, 8, 0, 128, 128, 128);
		DrawUiCell(CenterPosX + 292, 20, 4, 7, 7, 7, 0, 128, 128, 128);
		sprintf(StringTemp, "%d", PlayerStats.CoinCount);
		DrawText(StringTemp, CenterPosX + 300, 19, 0, 128, 128, 128);	
		
		
		// Do dialog
		if ((DialogState) && (PlayerInput[0].jump + PlayerInput[1].jump)) {
			if (PlayerInput[0].jump) Player[0].JumpPressed = true;
			if (PlayerInput[1].jump) Player[1].JumpPressed = true;
		}
		DoDialog(PlayerInput[0].jump + PlayerInput[1].jump + PlayerInput[0].pause + PlayerInput[1].pause);
		
		
		//DoWavyEffect();
		
		
		if (LvlHeader_ptr->Flags.NoFairy == false) DrawFairySprite(&Player[0]);
		DrawPlayerSprite(&Player[0]);
		
		
		DoProjectiles();
		DoEffects();
		
		DoEntities();
		DoCharacters();
		
		DrawFG();
		DrawBG();
		
		
		Display();
		
		
		if ((MenuAccept) && (TransOnGoing == false)) {
			switch(MenuAccept) {
				case 1:
					return(RESULT_RESTART);
					break;
				case 2:
					return(RESULT_QUIT);
					break;
			}
		}
		
	}
	
	
	wingame:
	
	ClearColor.red = ClearColor.grn = ClearColor.blu = 0;
	
	WinCount=0;
	while(1) {
		
		PrepDisplay();
		DoTransitions();
		
		BoxExpand -= BoxExpand/16;
		
		box.y = ScreenCenterY-((BoxExpand/ONE)/2);
		box.h = (BoxExpand/ONE);
		box.x = 0;
		box.w = ScreenXres;
		
		GsSortBoxFill(&box, &myOT[myActiveBuff], 0);
		
		DrawText("Level Completed!", CENTERED, ScreenCenterY - 4, 0, 128, 128, 128);
		
		if (WinCount < 180) {
			WinCount += 1;
		} else {
			if (WinCount == 180) {
				TransitionOut();
				WinCount = 181;
			}
			if (TransOnGoing == false) break;
		}
		
		Display();
		
	}
	
	return(RESULT_WINLEVEL);
	
	
	losegame:
	return(RESULT_GAMEOVER);
	
}

void FixStuff() {
	
	short i,cx,cy;
	short bx1,by1,bx2,by2;
	
	// Prepare fairy stuff
	for (i=0; i<NumPlayers; i++) {
		
		if (Player[i].Dir < 0) {
			Player[i].Fairy.x = (Player[i].x + 20);
		} else {
			Player[i].Fairy.x = (Player[i].x - 20);
		}
		
		Player[i].Fairy.y = (Player[i].y - 8);
		Player[i].Fairy.fx = ONE * Player[i].Fairy.x;
		Player[i].Fairy.fy = ONE * Player[i].Fairy.y;
		Player[i].Fairy.HurtCount = 0;
		Player[i].Fairy.dx = Player[i].Fairy.x;
		Player[i].Fairy.dy = Player[i].Fairy.y;
		
	}
	
	cx = Player[0].x;
	cy = Player[0].y - 10;
	
	bx1 = 0;
	by1 = 0;
	bx2 = LvlHeader_ptr->xdim;
	by2 = LvlHeader_ptr->ydim;
	
	// Check if player is in a camera lock sector
	for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
		if (SectorList_ptr[i].hitag == SEC_CAMERALOCK) {
			if (Inbox(cx/16, cy/16, SectorList_ptr[i].x1, SectorList_ptr[i].y1, SectorList_ptr[i].x2, SectorList_ptr[i].y2)) {
				bx1 = SectorList_ptr[i].x1;
				by1 = SectorList_ptr[i].y1;
				bx2 = SectorList_ptr[i].x2 + 1;
				by2 = SectorList_ptr[i].y2 + 1;
				break;
			}
		}
	}
	
	// Fix the camera to the player
	Camera.dx = Player[0].x - ScreenCenterX;
	Camera.dy = Player[0].y - ScreenCenterY;
	
	if ((bx2 - bx1) >= (ScreenXres / 16)) {
		if (Camera.dx > (16 * bx2) - (ScreenXres - 1))
			Camera.dx = (16 * bx2) - (ScreenXres - 1);
		if (Camera.dx < (16 * bx1))
			Camera.dx = 16 * bx1;
	} else {
		Camera.dx = -ScreenCenterX + ((((16 * ((bx2 - bx1) + 1)) / 2) - 8) + (16 * bx1));
	}
	
	if ((by2 - by1) >= (ScreenYres / 16)) {
		if (Camera.dy > (16 * by2) - (ScreenYres - 1))
			Camera.dy = (16 * by2) - (ScreenYres - 1);
		if (Camera.dy < (16 * by1))
			Camera.dy = 16 * by1;
	} else {
		Camera.dy = -ScreenCenterY + ((((16 * ((by2 - by1) + 1)) / 2) - 8) + (16 * by1));
	}
	
	Camera.dx = ONE * Camera.dx;
	Camera.dy = ONE * Camera.dy;
	Camera.fx = Camera.dx - 1;
	Camera.fy = Camera.dy - 1;
	
	Camera.x = Camera.fx / ONE;
	Camera.y = Camera.fy / ONE;
	
}
void DoWavyEffect() {
	
	static short	WaveInit=0;
	static short	WaveCount=0;
	static short	WaveFlip=0;
	static SPRITE	Row={0};
	
	int i,flip;
	
	Row.attribute			= 2 << 24;	// Set sprite as 16-bit since were mapping the image data directly from the display buffers
	Row.r = Row.g = Row.b	= 128;
	
	Row.u = 0;
	Row.h = 16;
	
	flip = WaveFlip;
	for (i=32; i<240; i+=32) {
		
		// Left half
		Row.w = 256;
		
		Row.v = i - WaveCount;
		
		Row.x = -(2-flip);
		Row.y = i - WaveCount;
		
		Row.tpage = GetTPage(2, 0, 0, 256*(1-myActiveBuff));
		
		GsSortFastSprite(&Row, &myOT[myActiveBuff], 0);

		// Right half
		Row.w = ScreenXres - 256;
		
		Row.v = i - WaveCount;
		
		Row.x = 256 - (2-flip);
		Row.y = i - WaveCount;
		
		Row.tpage = GetTPage(2, 0, 256, 256*(1-myActiveBuff));
		
		GsSortFastSprite(&Row, &myOT[myActiveBuff], 0);
		
		flip ^= 1;
	}
	
	WaveCount+=1;
	if (WaveCount >= 32) {
		WaveCount = 0;
		WaveFlip ^= 1;
	}
	
}
void GetInput() {
	
	int	PadStatus;
	
	// Controls stuff
	PadStatus = PadRead(0);
	
	PlayerInput[0].tap_up=0;
	if (PadStatus & PADLup)	{
		if (PlayerInput[0].up == 0) PlayerInput[0].tap_up=1;
		PlayerInput[0].up=1;
	} else {
		PlayerInput[0].up=0;
	}
	
	PlayerInput[0].tap_down=0;
	if (PadStatus & PADLdown) {
		if (PlayerInput[0].down == 0) PlayerInput[0].tap_down=1;
		PlayerInput[0].down=1;
	} else {
		PlayerInput[0].down=0;
	}
	
	PlayerInput[0].tap_left=0;
	if (PadStatus & PADLleft) {
		if (PlayerInput[0].left == 0) PlayerInput[0].tap_left=1;
		PlayerInput[0].left=1;
	} else {
		PlayerInput[0].left=0;
	}
	
	PlayerInput[0].tap_right=0;
	if (PadStatus & PADLright) {
		if (PlayerInput[0].right == 0) PlayerInput[0].tap_right=1;
		PlayerInput[0].right=1;
	} else {
		PlayerInput[0].right=0;
	}
	
	PlayerInput[0].tap_jump=0;
	if (PadStatus & PADRdown) {
		if (PlayerInput[0].jump == 0) PlayerInput[0].tap_jump=1;
		PlayerInput[0].jump=1;
	} else {
		PlayerInput[0].jump=0;
	}
	
	PlayerInput[0].tap_pause=0;
	if (PadStatus & PADstart) {
		if (PlayerInput[0].pause == 0) PlayerInput[0].tap_pause=1;
		PlayerInput[0].pause=1;
	} else {
		PlayerInput[0].pause=0;
	}
	
	if (PadStatus & PADRleft)	PlayerInput[0].run=1;		else	PlayerInput[0].run=0;
	if (PadStatus & PADRup)		PlayerInput[0].swap=1;		else	PlayerInput[0].swap=0;
	if (PadStatus & PADRright)	PlayerInput[0].throw=1;		else	PlayerInput[0].throw=0;
	if (PadStatus & PADselect)	PlayerInput[0].select=1;	else	PlayerInput[0].select=0;
	
}

void LoadLevelHeader(PckTOC *toc, char *filename) {
	
	int			i,px,py;
	GsIMAGE		FGtimParam;
	GsIMAGE		BGtimParam;
	SPRITEOBJ	SpriteObj;
	
	u_long		*SpriteObj_ptr;
	SECTOR		*Sector_ptr;
	char		*TxtData_ptr;
	
	u_char	HeaderBuff[HDRBUFF_SIZE];
	
	// Read the first sector only for now
	if (PckReadFile(toc, filename, (u_long*)&HeaderBuff[0], 2048) == 0) {
		sprintf(StringTemp, "%s CANNOT BE FOUND", filename);
		ErrorMessage(StringTemp);
	}
	CdReadSync(0, 0);
	
	// Grab the sector and transfer it into the header variable
	memcpy(LvlHeader_ptr, (u_long*)&HeaderBuff[0], 2048);
	
	// File checks
	if ((LvlHeader_ptr->ID[0] != 'M') && (LvlHeader_ptr->ID[0] != 'L') && (LvlHeader_ptr->ID[0] != 'V')) {
		sprintf(StringTemp, "%s - NOT A VALID FILE", filename);
		ErrorMessage(StringTemp);
	}
	
	if (LvlHeader_ptr->Version != 1) {
		sprintf(StringTemp, "%s - INVALID FORMAT VERSION", filename);
		ErrorMessage(StringTemp);		
	}
	
	// Proceed to load the rest of the header block
	PckReadFile(0, 0, (u_long*)&HeaderBuff[2048], q2sector(LvlHeader_ptr->BlockSize-2048));
	CdReadSync(0, 0);
	
	// Grab the header portion of the header block
	memcpy(LvlHeader_ptr, (u_long*)&HeaderBuff[0], sizeof(LVLHEADER));
	
	// Load the needed TIMs and calculate the sprite entries for each tile
	FGtimParam = LoadTIM(((u_long*)HeaderBuff)+(LvlHeader_ptr->FGtiles_ptr/4));
	
	// Generate a table of GsSPRITEs for drawing the tilemap
	for (i=1; i<256; i+=1) {
		*(FGtileSprite_ptr+(i-1)) = CalcSpriteCoords(FGtimParam, 16*(i%16), 16*(i/16), 16, 16, 0, 0);
	}
	
	// Only load background tiles if it is present
	if (LvlHeader_ptr->BGtiles_ptr) {
		
		BGtimParam = LoadTIM(((u_long*)HeaderBuff)+(LvlHeader_ptr->BGtiles_ptr/4));
		
		for (i=0; i<384; i++) {
			
			px = 16*(i%24);
			py = 16*(i/24);
			
			(BGtileCell_ptr+i)->cba		= GetClut(BGtimParam.cx, BGtimParam.cy);
			(BGtileCell_ptr+i)->tpage	= GetTPage(BGtimParam.pmode&3, 0, BGtimParam.px+(128*(px/256)), BGtimParam.py);
			(BGtileCell_ptr+i)->flag	= 0;
			
			(BGtileCell_ptr+i)->u		= px%256;
			(BGtileCell_ptr+i)->v		= py;
			
		}
		
		BGparam.attribute = (BGtimParam.pmode&3)<<24;
		BGparam.x = BGparam.y = 0;
		BGparam.scrollx = BGparam.scrolly = 0;
		BGparam.r = BGparam.g = BGparam.b = 128;
		BGparam.mx = BGparam.my = 0;
		BGparam.scalex = BGparam.scaley = ONE;
		BGparam.rotate = 0;
		
	}
	
	NumEntities = 0;
	NumCharacters = 0;
	NumEffects = 0;
	
	// Scan through the sprite object list
	if (LvlHeader_ptr->NumSprites > 0) {
		
		SpriteObj_ptr = (u_long*)&HeaderBuff+(LvlHeader_ptr->SpriteEntry_ptr/4);
		
		for (i=0; i<LvlHeader_ptr->NumSprites; i+=1) {
			
			SpriteObj = *(((SPRITEOBJ*)SpriteObj_ptr)+i);
			
			switch (SpriteObj.index) {
				case OBJ_PLAYER_START:
					StartPos.x = SpriteObj.x;
					StartPos.y = SpriteObj.y;
					if (SpriteObj.tag == 0) StartPos.dir = 1; else StartPos.dir = -1;
					break;
				
				case OBJ_GOALFLAG:
					AddEntity(SpriteObj.x, SpriteObj.y, 0, 0, ENT_GOALFLAG, SpriteObj.tag);
					break;
					
				// Entity objects
				case OBJ_COIN:
					AddEntity(SpriteObj.x, SpriteObj.y, 0, 0, ENT_COIN, SpriteObj.tag);
					break;
					
				case OBJ_FIREBOW:
					AddEntity(SpriteObj.x, SpriteObj.y, 0, 0, ENT_FIREBOW, 0);
					break;
					
				case OBJ_ICEBOW:
					break;
					
				case OBJ_DARKBOW:
					break;
				
				// Character objects
				case OBJ_NATALIE:
					AddCharacter(SpriteObj.x, SpriteObj.y, CHAR_NATALIE, 0, CHAR_NATALIE_HP);
					break;
					
				case OBJ_MONOHEAD:
					AddCharacter(SpriteObj.x, SpriteObj.y, CHAR_MONOHEAD, SpriteObj.tag, CHAR_MONOHEAD_HP);
					break;
				
			}
			
		}
		
	}
	
	
	// Retrieve the sector entries from the header
	Sector_ptr = (SECTOR*)((u_long*)HeaderBuff+(LvlHeader_ptr->SectorEntry_ptr/4));
	for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
		SectorList_ptr[i] = Sector_ptr[i];
	}
	
	
	// Get the script data from the header
	if (LvlHeader_ptr->TxtData_ptr) {
		TxtData_ptr = ((char*)HeaderBuff+LvlHeader_ptr->TxtData_ptr);
		for (i=0; TxtData_ptr[i] != 0x1a; i++) {
			ScriptCharBase_ptr[i] = TxtData_ptr[i];
		}
	}
	
	
	// Prepare the background data
	ClearColor = LvlHeader_ptr->ClearColor;
	for (i=0; i<3; i+=1) {
		BGscrollX[i] = 0;
		BGscrollY[i] = 0;
		for (py=0; py<16; py++) {
			for (px=0; px<32; px++) {
				if (LvlHeader_ptr->BGtilemap[i][py][px] == 0)
					LvlHeader_ptr->BGtilemap[i][py][px] = 0xFFFF;
			}
		}
	}
	
}
int PlayLevel(PckTOC *toc, char *filename) {
	
	int	result;
	
	// For level and tile data
	LVLHEADER	LevelHeader;
	GsSPRITE	FGtileSprite[255];
	GsCELL		BGtileCell[384];
	
	// List arrays
	FXSTRUCT	EffectsList[MAX_EFFECTS]		={0};
	PROJSTRUCT	ProjectileList[MAX_PROJECTILES]	={0};
	ENTSTRUCT	EntityList[MAX_ENTITIES]		={0};
	CHARSTRUCT	CharacterList[MAX_CHARACTERS]	={0};
	SECTOR		SectorList[MAX_SECTORS]			={0};
	
	// For the dialog script system
	char		ScriptBuff[1024*16]={0};
	
	
	// Prime the pointers
	LvlHeader_ptr		= &LevelHeader;
	FGtileSprite_ptr	= FGtileSprite;
	BGtileCell_ptr		= BGtileCell;
	
	EffectsList_ptr		= EffectsList;
	ProjectileList_ptr	= ProjectileList;
	EntityList_ptr		= EntityList;
	CharacterList_ptr	= CharacterList;
	SectorList_ptr		= SectorList;
	
	ScriptCharBase_ptr	= ScriptBuff;
	
	reload:
	
	
	// Load the level header
	LoadLevelHeader(toc, filename);
	
	
	// Begin main game loop
	result = GameLoop();
	ClearColor.red = ClearColor.grn = ClearColor.blu = 0;
	
	if (LevelHeader.TrackNum) XAremove();
	
	switch(result) {
		case RESULT_RESTART:
			goto reload;
			break;
		default:
			return(result);
			break;
		
	}
	
}

void DeleteSector(int num) {
	
	// Deletes a sector entry
	
	int i;
	
	// Swap the deleted sector
	LvlHeader_ptr->NumSectors -= 1;
	for (i=num; i<LvlHeader_ptr->NumSectors; i+=1) {
		*(SectorList_ptr+i) = *(SectorList_ptr+(i+1));
	}
	
}

void AddEntity(short x, short y, int xMove, int yMove, u_short Type, u_short Flag) {
	
	//	Adds an entity to the entity list (see the ENT_*** defs in globals.h for Type)
	
	ENTSTRUCT BlankEntity={0};
	
	if (NumEntities >= MAX_ENTITIES) return;
	
	EntityList_ptr[NumEntities]			=BlankEntity;
	
	EntityList_ptr[NumEntities].x		= x;
	EntityList_ptr[NumEntities].y		= y;
	EntityList_ptr[NumEntities].fx		= ONE * x;
	EntityList_ptr[NumEntities].fy		= ONE * y;
	EntityList_ptr[NumEntities].xMove	= xMove;
	EntityList_ptr[NumEntities].yMove	= yMove;
	EntityList_ptr[NumEntities].Type	= Type;
	EntityList_ptr[NumEntities].Flag	= Flag;
	
	NumEntities += 1;
	
}
void DeleteEntity(int EntNum) {
	
	// Deletes an entity from the entity list
	
	int i;
	
	// Swap the deleted entity out
	NumEntities -= 1;
	for (i=EntNum; i<NumEntities; i+=1) {
		*(EntityList_ptr+i) = *(EntityList_ptr+(i+1));
	}
	
}
void DoEntities() {
	
	int			i,c,cx,cy,OnFloor;
	int			Delete,Visible;
	int			LevelHeight=16*((LvlHeader_ptr)->ydim + 1);
	SPRITE		EntitySprite=PrepSprite(EntitySpritesTim);
	
	for (i=0; i<NumEntities; i+=1) {
		
		Delete=false;
		Visible=false;
		//EntityLogic(EntityList_ptr+i, &EntitySprite, LevelHeight, &Visible, &Delete);
		
		switch ((EntityList_ptr+i)->Type) {
			
			case ENT_COIN:
				
				EntitySprite.w = 10;
				EntitySprite.h = 10;
				EntitySprite.mx = 4;
				EntitySprite.my = 9;
				
				EntitySprite.x = (EntityList_ptr+i)->x - Camera.x;
				EntitySprite.y = (EntityList_ptr+i)->y - Camera.y;
				
				if (SpriteVisible(EntitySprite)) {
					
					EntitySprite.u = 0 + (10 * ((EntityList_ptr+i)->Count / 8));
					EntitySprite.v = 0;
					if (PauseAll == PAUSE_OFF)	(EntityList_ptr+i)->Count = (((EntityList_ptr+i)->Count + 1) % 32);
					
					EntitySprite.x -= EntitySprite.mx;
					EntitySprite.y -= EntitySprite.my;
					if ((EntityList_ptr+i)->LifeCount >= 480) {
						if (Flash) Visible = true;
					} else {
						Visible = true;
					}
					
				}
				
				// If flag is non-zero, the coin will fall and eventually disappear
				if ((EntityList_ptr+i)->Flag) {
					
					if (PauseAll == PAUSE_OFF) {
						(EntityList_ptr+i)->fx += (EntityList_ptr+i)->xMove;
						(EntityList_ptr+i)->fy += (EntityList_ptr+i)->yMove;
					}
					
					(EntityList_ptr+i)->x = (EntityList_ptr+i)->fx / ONE;
					(EntityList_ptr+i)->y = (EntityList_ptr+i)->fy / ONE;
					
					// Do collision detection
					switch (CollideT((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, 0, -10, &cy)) {
						#include "..\solidhits.c"
							(EntityList_ptr+i)->y = cy;
							(EntityList_ptr+i)->yMove = abs((EntityList_ptr+i)->yMove);
					}
					
					OnFloor = false;
					switch (CollideB((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, 0, 1, &cy)) {
						#include "..\solidhits.c"
							if ((EntityList_ptr+i)->yMove >= 0) {
								(EntityList_ptr+i)->yMove = -(EntityList_ptr+i)->yMove / 2;
							}
							if ((EntityList_ptr+i)->xMove)	(EntityList_ptr+i)->xMove *= 0.8f;
							(EntityList_ptr+i)->fy = (ONE * cy) + 2048;
							(EntityList_ptr+i)->y = cy;
							OnFloor = true;
					}
					
					switch (CollideL((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, -5, 0, &cx)) {
						#include "..\solidhits.c"
							(EntityList_ptr+i)->x = cx;
							(EntityList_ptr+i)->xMove = abs((EntityList_ptr+i)->xMove);
					}
					
					switch (CollideR((EntityList_ptr+i)->x, (EntityList_ptr+i)->y, 5, 0, &cx)) {
						#include "..\solidhits.c"
							(EntityList_ptr+i)->x = cx;
							(EntityList_ptr+i)->xMove = -abs((EntityList_ptr+i)->xMove);
					}
					
					// Make the coin move according to momentum
					if (PauseAll == PAUSE_OFF) {
						if (OnFloor == false)	(EntityList_ptr+i)->yMove += GRAVITY;
						if ((EntityList_ptr+i)->yMove > (ONE*FALL_LIMIT)) (EntityList_ptr+i)->yMove = ONE*FALL_LIMIT;
					}
					
					if ((EntityList_ptr+i)->y > LevelHeight) Delete = true;
					
					// Make the coin disappear after 10 seconds
					if (PauseAll == PAUSE_OFF) {
						(EntityList_ptr+i)->LifeCount += 1;
						if ((EntityList_ptr+i)->LifeCount >= 600) Delete = true;
					}
					
				}
				
				break;
			
			case ENT_FIREBOW:
			
				EntitySprite.w = 14;
				EntitySprite.h = 6;
				EntitySprite.mx = 6;
				EntitySprite.my = 5;
				
				EntitySprite.x = (EntityList_ptr+i)->x - Camera.x;
				EntitySprite.y = (EntityList_ptr+i)->y - Camera.y;
				
				if (SpriteVisible(EntitySprite)) {
				
					EntitySprite.u = 40;
					EntitySprite.v = 0;
					EntitySprite.y -= ((EntityList_ptr+i)->Count / 30);
					
					if (PauseAll == PAUSE_OFF) (EntityList_ptr+i)->Count = (((EntityList_ptr+i)->Count + 1) % 60);
					
					EntitySprite.x -= EntitySprite.mx;
					EntitySprite.y -= EntitySprite.my;
					Visible = true;
					
				}
				
				break;
				
			case ENT_GOALFLAG:
				
				EntitySprite.w = 30;
				EntitySprite.h = 48;
				
				EntitySprite.mx = 2;
				EntitySprite.my = 47;
				
				EntitySprite.x = (EntityList_ptr+i)->x - Camera.x;
				EntitySprite.y = (EntityList_ptr+i)->y - Camera.y;
				
				if (SpriteVisible(EntitySprite)) {
					
					EntitySprite.u = 30*((EntityList_ptr+i)->Count/10);
					EntitySprite.v = 33;
					
					if (PauseAll == PAUSE_OFF) (EntityList_ptr+i)->Count = (((EntityList_ptr+i)->Count + 1) % 40);
					
					EntitySprite.x -= EntitySprite.mx;
					EntitySprite.y -= EntitySprite.my;
					Visible = true;
					
				}
				
		}
		
		if (Visible) GsSortFastSprite(&EntitySprite, &myOT[myActiveBuff], 0);
		
		if (Delete) {
			DeleteEntity(i);
			i-=1;
		}
		
	}
	
}

void AddCharacter(short x, short y, u_short Type, u_short Tag, short Health) {

	CHARSTRUCT	BlankCharacter={0};
	
	if (NumCharacters >= MAX_CHARACTERS)	return;
	
	CharacterList_ptr[NumCharacters]		= BlankCharacter;
	CharacterList_ptr[NumCharacters].x		= x;
	CharacterList_ptr[NumCharacters].y		= y;
	CharacterList_ptr[NumCharacters].fx		= ONE * x;
	CharacterList_ptr[NumCharacters].fy		= ONE * y;
	CharacterList_ptr[NumCharacters].Type	= Type;
	CharacterList_ptr[NumCharacters].Tag	= Tag;
	CharacterList_ptr[NumCharacters].Health = Health;
	
	NumCharacters += 1;
	
}
void DeleteCharacter(int num) {
	
	int i;
	
	if (NumCharacters <= 0) return;
	
	NumCharacters -= 1;
	for (i=num; i<NumCharacters; i+=1) {
		CharacterList_ptr[i] = CharacterList_ptr[i+1];
	}
	
}
void DoCharacters(void) {
	
	int		i;
	int		px=0,py=0;
	int		Delete,Visible;
	SPRITE	Sprite;
	
	// Average the player coordinates if there's more than 1 player
	for (i=0; i<NumPlayers; i++) {
		px += Player[i].x;
		py += Player[i].y;
	}
	px /= NumPlayers;
	py /= NumPlayers;
	
	
	for (i=0; i<NumCharacters; i++) {
	
		Delete = false;
		Visible = false;
		
		CharacterLogic(CharacterList_ptr+i, &Sprite, px, py, &Delete, &Visible);
		
		if (Visible) GsSortFastSprite(&Sprite, &myOT[myActiveBuff], 0);
		
		if (Delete) {
			DeleteCharacter(i);
			i-=1;
		}
		
	}
	
}

void AddProjectile(short x, short y, int xMove, int yMove, u_short Type, u_short Owner) {
	
	PROJSTRUCT BlankProjectile={0};
	
	if (NumProjectiles >= MAX_PROJECTILES) return;
	
	ProjectileList_ptr[NumProjectiles] = BlankProjectile;
	
	ProjectileList_ptr[NumProjectiles].x		= x;
	ProjectileList_ptr[NumProjectiles].y		= y;
	ProjectileList_ptr[NumProjectiles].fx		= ONE*x;
	ProjectileList_ptr[NumProjectiles].fy		= ONE*y;
	ProjectileList_ptr[NumProjectiles].xMove	= xMove;
	ProjectileList_ptr[NumProjectiles].yMove	= yMove;
	ProjectileList_ptr[NumProjectiles].Type		= Type;
	ProjectileList_ptr[NumProjectiles].Owner	= Owner;
	
	NumProjectiles += 1;
	
}
void DeleteProjectile(int ProjNum) {
	
	int i;
	
	if (NumProjectiles <= 0) return;
	
	// Decrement the projectile count
	NumProjectiles -= 1;
	
	// Swap the deleted entity out
	for (i=ProjNum; i<NumProjectiles; i+=1) {
		ProjectileList_ptr[i] = ProjectileList_ptr[i+1];
	}
	
}
void DoProjectiles(void) {
	
	int			i=0;
	int			Delete=0;
	
	GsSPRITE	Sprite=PrepSprite(EntitySpritesTim);
	
	for (i=0; i<NumProjectiles; i+=1) {
	
		Delete=false;
		ProjectileLogic(ProjectileList_ptr + i, &Sprite, &Delete);
		
		GsSortFastSprite(&Sprite, &myOT[myActiveBuff], 0);
		
		if (Delete) {
			DeleteProjectile(i);
			i-=1;
		}
		
	}
	
}

void AddEffect(short x, short y, int xMove, int yMove, u_short Type, GsSPRITE *Sprite, u_char r, u_char g, u_char b) {
	
	FXSTRUCT BlankEffect={0};
	
	if (NumEffects >= MAX_EFFECTS) return;
	
	EffectsList_ptr[NumEffects] = BlankEffect;
	
	EffectsList_ptr[NumEffects].x			=x;
	EffectsList_ptr[NumEffects].y			=y;
	EffectsList_ptr[NumEffects].fx			=ONE*x;
	EffectsList_ptr[NumEffects].fy			=ONE*y;
	EffectsList_ptr[NumEffects].xMove		=xMove;
	EffectsList_ptr[NumEffects].yMove		=yMove;
	EffectsList_ptr[NumEffects].Type		=Type;
	
	EffectsList_ptr[NumEffects].r	=r;
	EffectsList_ptr[NumEffects].g	=g;
	EffectsList_ptr[NumEffects].b	=b;
	
	if (Sprite != NULL) {
		EffectsList_ptr[NumEffects].Sprite=*Sprite;
		EffectsList_ptr[NumEffects].Sprite.r=r;
		EffectsList_ptr[NumEffects].Sprite.g=g;
		EffectsList_ptr[NumEffects].Sprite.b=b;
	}
	
	NumEffects += 1;
	
}
void DeleteEffect(int num) {

	int i;
	
	// Decrement the entity count
	NumEffects -= 1;
	
	// Swap the deleted entity out
	for (i=num; i<NumEffects; i+=1) {
		EffectsList_ptr[i] = EffectsList_ptr[i+1];
	}
	
}
void DoEffects(void) {
	
	int			i,Delete;
	GsSPRITE	EntitySprite=PrepSprite(EntitySpritesTim);
	
	for (i=0; i<NumEffects; i+=1) {
		
		Delete=false;
		switch ((EffectsList_ptr+i)->Type) {
			case FX_BPARTICLE:	// A 6x6 brightening particle
				
				EffectsList_ptr[i].x = (EffectsList_ptr[i].fx / ONE) - Camera.x;
				EffectsList_ptr[i].y = (EffectsList_ptr[i].fy / ONE) - Camera.y;
				
				if (PauseAll == PAUSE_OFF) {
					
					EffectsList_ptr[i].fx		+= EffectsList_ptr[i].xMove;
					EffectsList_ptr[i].fy		+= EffectsList_ptr[i].yMove;
					EffectsList_ptr[i].xMove	*= 0.9f;
					EffectsList_ptr[i].yMove	-= 408;
					
				}
				
				EffectsList_ptr[i].Sprite	= EntitySprite;
				
				EffectsList_ptr[i].Sprite.attribute |= (1<<28)|(1<<30);
				
				EffectsList_ptr[i].Sprite.u	= 56;
				EffectsList_ptr[i].Sprite.v = 0;
				EffectsList_ptr[i].Sprite.w = 6;
				EffectsList_ptr[i].Sprite.h = 6;
				EffectsList_ptr[i].Sprite.mx = 2;
				EffectsList_ptr[i].Sprite.my = 2;
				
				EffectsList_ptr[i].Sprite.x = EffectsList_ptr[i].x;
				EffectsList_ptr[i].Sprite.y = EffectsList_ptr[i].y;
				
				EffectsList_ptr[i].Sprite.r = EffectsList_ptr[i].r;
				EffectsList_ptr[i].Sprite.g = EffectsList_ptr[i].g;
				EffectsList_ptr[i].Sprite.b = EffectsList_ptr[i].b;
				
				if (PauseAll == PAUSE_OFF)				EffectsList_ptr[i].Count += 1;
				if ((EffectsList_ptr+i)->Count > 30)	Delete = true;
				
				GsSortFastSprite(&EffectsList_ptr[i].Sprite, &myOT[myActiveBuff], 0);
				
				break;
				
			case FX_SPRITEBIT: // WORK NEEDED
				
				EffectsList_ptr[i].Sprite.x = (EffectsList_ptr[i].fx / ONE) - Camera.x;
				EffectsList_ptr[i].Sprite.y = (EffectsList_ptr[i].fy / ONE) - Camera.y;
				
				if (SpriteVisible(EffectsList_ptr[i].Sprite)) {
					
					GsSortSprite(&EffectsList_ptr[i].Sprite, &myOT[myActiveBuff], 0);
					
					if (PauseAll == PAUSE_OFF) {
						EffectsList_ptr[i].fx += EffectsList_ptr[i].xMove;
						EffectsList_ptr[i].fy += EffectsList_ptr[i].yMove;
						EffectsList_ptr[i].Sprite.rotate += (EffectsList_ptr[i].xMove * 4);
						EffectsList_ptr[i].yMove += GRAVITY;
					}
					
				} else {
					Delete = true;
				}
				
				break;
				
		}
		
		if (Delete) {
			
			DeleteEffect(i);
			i-=1;
			
		}
		
	}
	
}

// Screen transitioning stuff
void TransitionOut() {
	
	if (TransOnGoing == false) {
		TransState=1;
		TransCount=0;
		TransOnGoing=true;
	}
	
}
void TransitionIn() {
	
	if (TransOnGoing == false) {
		TransState=0;
		TransCount=48;
		TransOnGoing=true;
	}
	
}
void DoTransitions() {

	GsBOXF Box = { 0, 0, 0, ScreenXres, 16 , 0, 0, 0 };
	int BoxHeight=0;
	int i=0;

	if (TransCount) {
	
		for (i=0;i<15;i+=1) {
			
			if (TransCount > (2 * i)) {
			
				BoxHeight = TransCount - (2 * i);
				
				if (BoxHeight < 0)
					BoxHeight = 0;
					
				if (BoxHeight > 16)
					BoxHeight = 16;
				
				if (BoxHeight > 0) {
				
					if (TransState) {
						Box.y = (16 * i);
						Box.h = BoxHeight;
						GsSortBoxFill(&Box, &myOT[myActiveBuff], 0);
					} else {
						Box.y = (16 * (14 - i)) + (16 - BoxHeight);
						Box.h = BoxHeight;
						GsSortBoxFill(&Box, &myOT[myActiveBuff], 0);						
					}
					
				}
			
			}
			
		}
		
	}
	
	TransOnGoing = false;
	if (TransState) {
		if (TransCount < 48) {
			TransCount += 1;
			TransOnGoing = true;
		}
	} else {
		if (TransCount > 0) {
			TransCount -= 1;
			TransOnGoing = true;
		}
	}
	
}

void DrawPlayerSprite(PLAYERSTUFF *pstuff) {
	
	pstuff->Sprite.x = (pstuff->x - Camera.x);
	pstuff->Sprite.y = (pstuff->y - Camera.y);
	
	pstuff->Sprite.w	= 13;
	pstuff->Sprite.h	= 24;
	pstuff->Sprite.mx	= 6;
	pstuff->Sprite.my	= 23;
	
	if (SpriteVisible(pstuff->Sprite)) {
		
		DrawPlayerSpriteLogic(pstuff);
		
		if (pstuff->HurtCount < 2) {
			GsSortFastSprite(&pstuff->Sprite, &myOT[myActiveBuff], 0);
		} else {
			if (Flash) GsSortFastSprite(&pstuff->Sprite, &myOT[myActiveBuff], 0);
		}
		
	}
	
}
void DrawFairySprite(PLAYERSTUFF *pstuff) {
	
	pstuff->Fairy.Sprite.w	= 20;
	pstuff->Fairy.Sprite.h	= 20;
	pstuff->Fairy.Sprite.mx	= 10;
	pstuff->Fairy.Sprite.my	= 20;
		
	pstuff->Fairy.Sprite.x = (pstuff->Fairy.x - Camera.x);
	if (pstuff->Death == false) {
		pstuff->Fairy.Sprite.y = (pstuff->Fairy.y - Camera.y) + Bobbing;
	} else {
		pstuff->Fairy.Sprite.y = (pstuff->Fairy.y - Camera.y);
	}
	
	if (SpriteVisible(pstuff->Fairy.Sprite)) {
		
		DrawFairySpriteLogic(pstuff);
		
		if (pstuff->Fairy.HurtCount >= 10) {
			if (Flash) GsSortFastSprite(&pstuff->Fairy.Sprite, &myOT[myActiveBuff], 0);
		} else if (pstuff->Fairy.HurtCount == 0) {
			GsSortFastSprite(&pstuff->Fairy.Sprite, &myOT[myActiveBuff], 0);
		}
		
	}
	
}

void DrawUiCell(short x, short y, short cx, short cy, short cw, short ch, char trans, char r, char g, char b) {
	
	uiCellSprite.attribute |= (1 << 30);
	uiCellSprite.r = r;
	uiCellSprite.g = g;
	uiCellSprite.b = b;
	
	uiCellSprite.x = x;
	uiCellSprite.y = y;
	
	uiCellSprite.u = 8 * cx;
	uiCellSprite.v = 8 * cy;
	
	uiCellSprite.w = cw;
	uiCellSprite.h = ch;

	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	
}
void DrawMenuPanel(int x1, int y1, int x2, int y2, int DrawTop) {

	int px1,py1;
	int px2,py2;
	int pXdim,pYdim;
	
	int ex,ey;
	
	px1 = (x1); py1 = (y1);
	px2 = (x2 - 7); py2 = (y2 - 7);
	pXdim = (px2 - px1);
	pYdim = (py2 - py1);
	
	if (pXdim < 8) return;
	if (pYdim < 8) return;
	
	if (DrawTop) {
		DrawUiCell(px1 + ((pXdim / 2) - 8), py1, 0, 4, 24, 8, 0, 128, 128, 128);
	}
	
	// Draw the corners
	DrawUiCell(px1, py1, 0, 0, 8, 8, 0, 128, 128, 128);
	DrawUiCell(px2, py1, 4, 0, 8, 8, 0, 128, 128, 128);
	DrawUiCell(px2, py2, 4, 3, 8, 8, 0, 128, 128, 128);
	DrawUiCell(px1, py2, 0, 3, 8, 8, 0, 128, 128, 128);
	
	// Fill the edges
	for (ex=8;ex<(pXdim-15);ex=ex+16) {
		DrawUiCell(px1 + ex, py1, 1, 0, 16, 8, 0, 128, 128, 128);
		DrawUiCell(px1 + ex, py2, 1, 3, 16, 8, 0, 128, 128, 128);
		DrawUiCell(px1 + ex, py2 - ((pYdim - 8) % 16), 1, 1, 16, (pYdim - 8) % 16, 0, 128, 128, 128);
	}
	DrawUiCell(px2 - ((pXdim - 8) % 16), py1, 1, 0, (pXdim - 8) % 16, 8, 0, 128, 128, 128);
	DrawUiCell(px2 - ((pXdim - 8) % 16), py2, 1, 3, (pXdim - 8) % 16, 8, 0, 128, 128, 128);

	for (ey=8;ey<(pYdim-15);ey=ey+16) {
		DrawUiCell(px1, py1 + ey, 0, 1, 8, 16, 0, 128, 128, 128);
		DrawUiCell(px2, py1 + ey, 4, 1, 8, 16, 0, 128, 128, 128);
		DrawUiCell(px2 - ((pXdim - 8) % 16), py1 + ey, 1, 1, (pXdim - 8) % 16, 16, 0, 128, 128, 128);
	}
	DrawUiCell(px1, py2 - ((pYdim - 8) % 16), 0, 1, 8, (pYdim - 8) % 16, 0, 128, 128, 128);
	DrawUiCell(px2, py2 - ((pYdim - 8) % 16), 4, 1, 8, (pYdim - 8) % 16, 0, 128, 128, 128);
	
	for (ex=8;ex<(pXdim-15);ex=ex+16) {
		for (ey=8;ey<(pYdim-15);ey=ey+16) {
			DrawUiCell(px1 + ex, py1 + ey, 1, 1, 16, 16, 1, 128, 128, 128);
		}
	}
	DrawUiCell(px2 - ((pXdim - 8) % 16), py2 - ((pYdim - 8) % 16), 1, 1, (pXdim - 8) % 16, (pYdim - 8) % 16, 0, 128, 128, 128);
	
}
void DrawText(char *text, short x, short y, char trans, char r, char g, char b) {
	
	short	c;
	short	cx,cy;
	short	TextLen=0;
	
	uiCellSprite.attribute |= (trans << 30);
	uiCellSprite.r = r;
	uiCellSprite.g = g;
	uiCellSprite.b = b;
	
	uiCellSprite.x = x;
	uiCellSprite.y = y;
	uiCellSprite.w = 8;
	uiCellSprite.h = 8;
	
	if (x == CENTERED) {
		for (c=0; text[c] != NULL; c+=1) {
			if (text[c] >= 32) TextLen = TextLen + CharWidthTable[text[c] - 32];
		}
		uiCellSprite.x = ScreenCenterX - (TextLen / 2);
	}
	
	for (c=0; text[c] != NULL; c=c+1) {
		
		if (text[c] >= 33) {
		
			cx = (text[c] - 33) % 10;
			cy = (text[c] - 33) / 10;
			
			uiCellSprite.u = 48 + (8 * cx);
			uiCellSprite.v = 8 * cy;
			
			GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
			
		}
		
		if (text[c] >= 32) uiCellSprite.x += CharWidthTable[text[c]-32];
		
	}
	
}
void DrawTextSmall(char *text, short x, short y, char trans, char r, char g, char b) {
	
	short c;
	short cx,cy;
	short TextLen=0;
	
	uiCellSprite.attribute |= (trans << 30);
	uiCellSprite.r = r;
	uiCellSprite.g = g;
	uiCellSprite.b = b;
	
	uiCellSprite.x = x;
	uiCellSprite.y = y;
	uiCellSprite.w = 8;
	uiCellSprite.h = 8;
	
	if (x == CENTERED) {
		for (c=0; *(text+c)!=NULL; c+=1) {
			if (*(text+c) >= 32) TextLen = TextLen + CharWidthTableSmall[*(text+c) - 32];
		}
		uiCellSprite.x = ScreenCenterX - (TextLen / 2);
	}
	
	for (c=0; *(text+c)!=NULL; c=c+1) {
		
		if (*(text+c) >= 33) {
		
			cx = (*(text+c) - 33) % 10;
			cy = (*(text+c) - 33) / 10;
			
			uiCellSprite.u = 48 + (8 * cx);
			uiCellSprite.v = 88 + (8 * cy);
			
			GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
			
		}
		
		if (*(text+c) >= 32) uiCellSprite.x += CharWidthTableSmall[*(text+c)-32];
		
	}
	
}
void DrawHScrollBar(int x, int y, int length, int val, int maxval) {
	
	int i;
	
	uiCellSprite.w = 4;
	uiCellSprite.h = 8;
	uiCellSprite.u = 0;
	uiCellSprite.v = 64;
	
	uiCellSprite.x = (x+4) + ((length-19) * ((float)val/(float)maxval));
	uiCellSprite.y = y;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	
	
	uiCellSprite.w = 8;
	uiCellSprite.h = 8;
	
	uiCellSprite.x = x;
	uiCellSprite.y = y;
	uiCellSprite.u = 0;
	uiCellSprite.v = 56;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	
	uiCellSprite.x = (x+length)-15;
	uiCellSprite.u = 16;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);

	uiCellSprite.u = 8;
	for (i=0; i<((length-16)/8); i++) {
		uiCellSprite.x = (x+8)+(8*i);
		GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	}
	
}
void DrawVScrollBar(int x, int y, int length, int val, int maxval) {
	
	int i;
	
	uiCellSprite.w = 8;
	uiCellSprite.h = 4;
	uiCellSprite.u = 24;
	uiCellSprite.v = 80;
	
	uiCellSprite.x = x;
	uiCellSprite.y = (y+4) + ((length-19) * ((float)val/(float)maxval));;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	
	
	uiCellSprite.w = 8;
	uiCellSprite.h = 8;
	
	uiCellSprite.x = x;
	uiCellSprite.y = y;
	uiCellSprite.u = 24;
	uiCellSprite.v = 56;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	
	uiCellSprite.y = (y+length)-15;
	uiCellSprite.v = 72;
	GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);

	uiCellSprite.v = 64;
	for (i=0; i<((length-16)/8); i++) {
		uiCellSprite.y = (y+8)+(8*i);
		GsSortFastSprite(&uiCellSprite, &myOT[myActiveBuff], 0);
	}
	
}

void LoadGlobalStuff() {
	
	int		i;
	u_char	FileBuff[GBLBUFF_SIZE];
	QLPFILE	QLPentry;
	
	PckReadFile(&PackTOC[0], "GLOBAL.QLP", (u_long*)FileBuff, 0);
	CdReadSync(0, 0);
	
	#if DEBUG
	printf("Loading sound files...");
	#endif
	
	// Load each sound from the QLP file into SPU memory
	for (i=0; i<NUM_SOUNDS; i+=1) {
		QLPentry = QLPgetFileInfo((u_long*)FileBuff, i);
		LoadVAG(i, (u_char*)QLPgetFilePtr((u_long*)FileBuff, i), QLPentry.Size);
	}
	
	#if DEBUG
	printf("Done.\n");
	#endif
	
	uiGraphTim = LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "UI_GRAPH.TIM")));
	uiCellSprite = PrepSprite(uiGraphTim);
	
}
void LoadTitleGraphics() {
	
	u_char FileBuff[GFXBUFF_SIZE];
	
	PckReadFile(&PackTOC[0], "TITLE_GFX.QLP", (u_long*)&FileBuff[0], 0);
	CdReadSync(0, 0);
	
	TempTim[0] = LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "MTEKLOGO.TIM")));
	TempTim[1] = LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "CB14LOGO.TIM")));
	TempTim[2] = LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "TITLE.TIM")));
	
}
void LoadGameGraphics() {

	u_char FileBuff[GFXBUFF_SIZE];
	
	PckReadFile(&PackTOC[0], "GAME_GFX.QLP", (u_long*)&FileBuff[0], 0);
	CdReadSync(0, 0);
	
	PlayerSpritesTim[0]		= LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "PSPRITE0.TIM")));
	EntitySpritesTim		= LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "ESPRITES.TIM")));
	CharacterSpritesTim[0]	= LoadTIM(QLPgetFilePtr((u_long*)FileBuff, QLPsearchFile((u_long*)FileBuff, "CHARSPR0.TIM")));
	
	
	Player[0].Sprite		= PrepSprite(PlayerSpritesTim[0]);
	Player[0].Fairy.Sprite	= Player[0].Sprite;
	
	CharacterSprite[0]		= PrepSprite(CharacterSpritesTim[0]);
	
}

void DrawFG() {

	int 	tStartX,tStartY;
	int 	tEndX,tEndY;
	int		tx,ty;
	int		tpx,tpy;
	u_char	*TileNum_ptr;
	
	tDrawXdim = (ScreenXres / 16) + 1;
	tDrawYdim = (ScreenYres / 16) + 1;
	
	tStartX = Camera.x / 16;
	tStartY = Camera.y / 16;
	tEndX = tStartX + tDrawXdim;
	tEndY = tStartY + tDrawYdim;
	
	if (tStartX < 0)	tStartX = 0;
	if (tStartY < 0)	tStartY = 0;
	if (tEndX < 0)		tEndX = 0;
	if (tEndY < 0)		tEndY = 0;
	if (tStartX > (LvlHeader_ptr->xdim - 1))	tStartX = (LvlHeader_ptr->xdim - 1);
	if (tStartY > (LvlHeader_ptr->ydim - 1))	tStartY = (LvlHeader_ptr->ydim - 1);
	if (tEndX > (LvlHeader_ptr->xdim - 1))		tEndX = (LvlHeader_ptr->xdim - 1);
	if (tEndY > (LvlHeader_ptr->ydim - 1))		tEndY = (LvlHeader_ptr->ydim - 1);
	
	tpy = (16 * tStartY) - Camera.y;
	for (ty=tStartY; ty<=tEndY; ty+=1) {
		tpx = (16 * tStartX) - Camera.x;
		
		TileNum_ptr = (LvlData_ptr+(tStartX+(LvlHeader_ptr->xdim*ty)));
		
		// Draw the row
		for (tx=tStartX; tx<=tEndX; tx+=1) {
			
			// If tile is non-zero, sort it
			if (*TileNum_ptr) {
				(FGtileSprite_ptr+(*TileNum_ptr-1))->x = tpx;
				(FGtileSprite_ptr+(*TileNum_ptr-1))->y = tpy;
				GsSortFastSprite(FGtileSprite_ptr+(*TileNum_ptr-1), &myOT[myActiveBuff], 0);
			}
			
			// Next tile
			tpx += 16;
			TileNum_ptr++;
			
		}
		tpy += 16;
	}
	
}
void DrawBG() {
	
	int	i;
	int ldist;
	int lx,ly;
	int	tScreenCenterX = 320;
	GsMAP	BGmap;
	
	BGmap.cellw		= 16;
	BGmap.cellh		= 16;
	BGmap.ncellw	= 32;
	BGmap.ncellh	= 16;
	BGmap.base		= BGtileCell_ptr;	// Pointer to our GsCELL table
	
	BGparam.w = ScreenXres;
	BGparam.h = ScreenYres;
	BGparam.map = &BGmap;
	
	// Draw the layers
	for (i=0; i<4; i++) {
		
		if (LvlHeader_ptr->BGactive[i]) {
			
			ldist = tScreenCenterX + (LvlHeader_ptr->BGdistRate * (1 + i));
			
			switch (LvlHeader_ptr->BGscrollMode[i].xscroll) {
				case 0:
					lx=0;
					BGscrollX[i]=0;
					break;
				case 1:
					lx = Camera.x * ((float)tScreenCenterX / ldist);
					BGscrollX[i]=0;
					break;
				case 2:
					if (PauseAll == PAUSE_OFF) BGscrollX[i] += (1.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollX[i] > 512)	BGscrollX[i] -= 512;
					lx = -BGscrollX[i] + (Camera.x * ((float)tScreenCenterX / ldist));
					break;
				case 3:
					if (PauseAll == PAUSE_OFF) BGscrollX[i] += (1.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollX[i] > 512)	BGscrollX[i] -= 512;
					lx = BGscrollX[i] + (Camera.x * ((float)tScreenCenterX / ldist));
					break;
				case 4:
					if (PauseAll == PAUSE_OFF) BGscrollX[i] += (2.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollX[i] > 512)	BGscrollX[i] -= 512;
					lx = -BGscrollX[i] + (Camera.x * ((float)tScreenCenterX / ldist));
					break;
				case 5:
					if (PauseAll == PAUSE_OFF) BGscrollX[i] += (2.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollX[i] > 512)	BGscrollX[i] -= 512;
					lx = BGscrollX[i] + (Camera.x * ((float)tScreenCenterX / ldist));
					break;
			}
			
			switch (LvlHeader_ptr->BGscrollMode[i].yscroll) {
				case 0:
					ly=0;
					BGscrollY[i]=0;
					break;
				case 1:
					ly = Camera.y * ((float)tScreenCenterX / ldist);
					BGscrollY[i]=0;
					break;
				case 2:
					if (PauseAll == PAUSE_OFF) BGscrollY[i] += (2.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollY[i] > 256)	BGscrollY[i] -= 256;
					ly = -BGscrollY[i] + (Camera.y * ((float)tScreenCenterX / ldist));
					break;
				case 3:
					if (PauseAll == PAUSE_OFF) BGscrollY[i] += (2.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollY[i] > 256)	BGscrollY[i] -= 512;
					ly = BGscrollY[i] + (Camera.y * ((float)tScreenCenterX / ldist));
					break;
				case 4:
					if (PauseAll == PAUSE_OFF) BGscrollY[i] += (4.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollY[i] > 256)	BGscrollY[i] -= 512;
					ly = -BGscrollY[i] + (Camera.y * ((float)tScreenCenterX / ldist));
					break;
				case 5:
					if (PauseAll == PAUSE_OFF) BGscrollY[i] += (4.0f * ((float)tScreenCenterX / ldist));
					if (BGscrollY[i] > 256)	BGscrollY[i] -= 256;
					lx = BGscrollY[i] + (Camera.y * ((float)tScreenCenterX / ldist));
					break;
			}
			
			if (LvlHeader_ptr->BGscrollMode[i].xwrap == false) {
				BGparam.x = -(lx + LvlHeader_ptr->BGxOffset[i]);
				BGparam.scrollx = 0;
				BGparam.w = ScreenXres;
			} else {
				BGparam.x = 0;
				BGparam.w = ScreenXres;
				BGparam.scrollx = wrap(lx + LvlHeader_ptr->BGxOffset[i], 512);
			}
			
			if (LvlHeader_ptr->BGscrollMode[i].ywrap == false) {
				BGparam.y = -(ly + LvlHeader_ptr->BGyOffset[i]);
				BGparam.scrolly = 0;
				BGparam.h = 256;
			} else {
				BGparam.y = 0;
				BGparam.scrolly = wrap(ly + LvlHeader_ptr->BGyOffset[i], 256);
			}
			
			BGmap.index	= (u_short*)&LvlHeader_ptr->BGtilemap[i][0][0];
			GsSortFastBg(&BGparam, &myOT[myActiveBuff], 0);
			
		}
		
	}

}

void init() {
	
	int				i;
	RECT			ClearRect = { 0, 0, 384, 512 };
	SpuCommonAttr	CommonAttr={0};
	
	SpuInit();
	SpuInitMalloc(NUM_SOUNDS, ss_malloc_table);
	CdInit();
	
	
	CommonAttr.mask = (SPU_COMMON_MVOLL | SPU_COMMON_MVOLR);
	CommonAttr.mvol.left  = 0x3fff; //64*ss_sfxvol_left;
	CommonAttr.mvol.right = 0x3fff; //64*ss_sfxvol_right;
	SpuSetCommonAttr(&CommonAttr);
	
	
	// Initialize and prepare the graphics system
	GsInitGraph(ScreenXres, ScreenYres, GsNONINTER|GsOFSGPU, 0, 0);
	ClearImage(&ClearRect, 0, 0, 0);
	GsDefDispBuff(0, 0, 0, 256);

	myOT[0].length = OT_LENGTH;
	myOT[1].length = OT_LENGTH;
	myOT[0].org = myOT_TAG[0];
	myOT[1].org = myOT_TAG[1];
	
	GsClearOt(0, 0, &myOT[0]);
	GsClearOt(0, 0, &myOT[1]);
	
	FntLoad(960, 0);
	FntOpen(0, 0, ScreenXres, ScreenYres, 0, 512);
	
	
	ScreenCenterX = ScreenXres / 2;
	ScreenCenterY = ScreenYres / 2;
	
	
	// Prepare the main XA files for playback
	XAinitFile(&XAfiles[0]);
	
	//InitXA();
	
	
	// Check if a CD menu is present on the disc
	MenuPresent = CdMenuPresent();
	
	
	// Get TOC infos of all PCK files
	if (PckGetToc("\\MARILYN\\GAMEDATA.PCK", &PackTOC[0]) == 0)	ErrorMessage("GAMEDATA.PCK NOT FOUND ON DISC");
	if (PckGetSubToc(&PackTOC[0], "LEVELS.PCK", &PackTOC[1]) == 0) 	ErrorMessage("LEVELS.PCK NOT FOUND IN GAMEDATA.PCK");
	
	LoadGlobalStuff();
	
	PadInit(0);
	//MemCardInit(0);
	if (*(char *)0xbfc7ff52=='E')	SetPAL();
	
	//CheckCards();
	
	
	// Check the console's region if it is a PAL unit or not
	if (VideoMode == 1) {
		
		ClearColor.red = ClearColor.grn = ClearColor.blu = 0;
		
		while(PlayerInput[0].jump == 0) {
			
			PrepDisplay();
			GetInput();
			
			DrawText("Looks like your playing this game on a PAL region system.", CENTERED, 90, 0, 128, 128, 128);
			DrawText("Unfortunately, this game is timed for NTSC so the game", CENTERED, 100, 0, 128, 128, 128);
			DrawText("runs 16.7% slower than normal under PAL mode.", CENTERED, 110, 0, 128, 128, 128);
			DrawText("For more info, see readme.txt inside the game disc.", CENTERED, 130, 0, 128, 128, 128);
			
			StringTemp[0] = 0;
			strcat(StringTemp, "Press ");
			CharTemp[0] = CHR_CROSS; strcat(StringTemp, CharTemp);
			strcat(StringTemp, " to continue.");
			
			DrawText(StringTemp, CENTERED, 150, 0, 128, 128, 128);
			
			Display();
			
		}
		
		PlaySound(SND_SELECT, -1, ONE, 0);
		
	}
	
	
	for(i=0; i<60; i++) {
		PrepDisplay();
		DrawText("This novelty fan-game is not licensed or endorsed by", CENTERED, 115, 0, 2*i, 2*i, 2*i);
		DrawText("Sony Computer Entertainment Inc.", CENTERED, 125, 0, 2*i, 2*i, 2*i);
		Display();
	}
	for(i=0; i<120; i++) VSync(0);
	for(i=60; i>0; i--) {
		PrepDisplay();
		DrawText("This novelty fan-game is not licensed or endorsed by", CENTERED, 115, 0, 2*i, 2*i, 2*i);
		DrawText("Sony Computer Entertainment Inc.", CENTERED, 125, 0, 2*i, 2*i, 2*i);
		Display();
	}
	
}

// Memory card stuff
void CheckCards() {
	
	short i;
	short Slot1result,Slot2result;
	
	ClearColor.red = ClearColor.grn = ClearColor.blu = 0;
	
	#if DEBUG
	printf("Checking memory card slots...\n");
	#endif
	
	// Check for any present cards
	//Slot1result = MemCardExist(0x00);
	//MemCardSync(0, 0, 0);
	//Slot2result = MemCardExist(0x10);
	//MemCardSync(0, 0, 0);

	#if DEBUG
	printf("Ok!\n");
	#endif
	
	//if ((Slot1result == McErrNone) && (Slot2result == McErrNone)) {
		while(1) {
			
			PrepDisplay();
			
			DrawMenuPanel(ScreenCenterX-70, 100, ScreenCenterX+70, 140, false);
			DrawText("Which Memory Card would you like to use?", CENTERED, 110, 0, 128, 128, 128);
			DrawText("Slot 1", CENTERED, 115, 0, 128, 128, 128);
			DrawText("Slot 2", CENTERED, 125, 0, 128, 128, 128);
			
			Display();
			
		}
	//
	
	/*for(i=0; i<4; i++) {
		
		PrepDisplay();
		
		DrawMenuPanel(ScreenCenterX-70, 110, ScreenCenterX+70, 130, false);
		DrawText("", CENTERED, 115, 0, 128, 128, 128);
		DrawText(line2, CENTERED, 125, 0, 128, 128, 128);
		
		Display();
		
	}
	*/
	
}

void PrepDisplay() {
	
	myActiveBuff = GsGetActiveBuff();
	GsSetWorkBase((PACKET*)GPUPacketArea[myActiveBuff]);
	GsClearOt(0, 0, &myOT[myActiveBuff]);
	
}
void Display() {
	
	#if DEBUG
	FntFlush(-1);
	#endif
	

	VSync(0);
	GsSwapDispBuff();
	GsSortClear(ClearColor.red, ClearColor.grn, ClearColor.blu, &myOT[myActiveBuff]);
	GsDrawOt(&myOT[myActiveBuff]);
	
	FlashCount += 1;
	if (FlashCount > 1) {
		Flash ^= 1;
		FlashCount = 0;
	}
	
	BobbingCount += 1;
	if (BobbingCount >= 30) {
		Bobbing ^= 1;
		BobbingCount = 0;
	}
	
}
void Set4x3() {

	ScreenXres = 320;
	GsInitGraph2(ScreenXres, ScreenYres, GsNONINTER|GsOFSGPU, 0, 0);
	
	ScreenCenterX = (ScreenXres - 1) / 2;
	ScreenCenterY = (ScreenYres - 1) / 2;
	CenterPosX = 0;
	AspectMode = 0;
	
}
void Set16x9() {

	ScreenXres = 384;
	GsInitGraph2(ScreenXres, ScreenYres, GsNONINTER|GsOFSGPU, 0, 0);
	
	ScreenCenterX = (ScreenXres - 1) / 2;
	ScreenCenterY = (ScreenYres - 1) / 2;
	CenterPosX = ScreenCenterX - 160;
	AspectMode = 1;
	
}
void SetNTSC() {
	
	SetVideoMode(MODE_NTSC);
	GsDISPENV.screen.x = DisplayXpos;
	GsDISPENV.screen.y = DisplayYpos;
	VideoMode = 0;
	
}
void SetPAL() {
	
	SetVideoMode(MODE_PAL);
	GsDISPENV.screen.x = DisplayXpos;
	GsDISPENV.screen.y = 28 + DisplayYpos;
	VideoMode = 1;
	
}

int InSector(int x, int y) {
	
	int i,tx=x/16,ty=y/16;
	
	for (i=0; i<LvlHeader_ptr->NumSectors; i++) {
		if (Inbox(tx, ty, SectorList_ptr[i].x1, SectorList_ptr[i].y1, SectorList_ptr[i].x2, SectorList_ptr[i].y2)) {
			return(i);
		}
	}
	
	return(-1);
	
}
int SpriteVisible(GsSPRITE sprite) {

	if (((sprite.x+(sprite.w-1))-sprite.mx >= 0) && ((sprite.x-sprite.mx) <= (ScreenXres-1))) {
		if (((sprite.y-sprite.my)+(sprite.h-1) >= 0) && ((sprite.y-sprite.my) <= (ScreenYres-1))) {
			return(true);
		}
	}
	return(false);

}
void SortImage(int x, int y, GsIMAGE TimImage, u_char red, u_char grn, u_char blu) {

	// Returns a GsSPRITE structure so that TimImage can be displayed using GsSortSprite.

	GsSPRITE tSprite;
	
	int ClipNeeded=0;
	int ImageWidth=0;
	
	// Set texture size and coordinates
	switch (TimImage.pmode & 3) {
		case 0: // 4-bit
			tSprite.w = TimImage.pw << 2;
			tSprite.u = (TimImage.px & 0x3f) * 4;
			break;
			
		case 1: // 8-bit
			tSprite.w = TimImage.pw << 1;
			
			if (tSprite.w > 256) {
				tSprite.w = 256;
				ClipNeeded = 1;
			}
			
			tSprite.u = (TimImage.px & 0x3f) * 2;
			break;
			
		default: // 16-bit
			tSprite.w = TimImage.pw;
			tSprite.u = TimImage.px & 0x3f; 
			
    };
	
	tSprite.h = TimImage.ph;
	tSprite.v = TimImage.py & 0xff;

	// Set texture page and attributes
	tSprite.tpage 		= GetTPage((TimImage.pmode & 3), 0, TimImage.px, TimImage.py);
	tSprite.attribute 	= ((TimImage.pmode & 3)<<24)|(1<<30);
	
	// CLUT coords
	tSprite.cx 			= TimImage.cx;
	tSprite.cy 			= TimImage.cy;
	
	// Default position, color intensity, and scale/rotation values
	tSprite.mx = tSprite.my				= 0;
	tSprite.r = red;
	tSprite.g = grn;
	tSprite.b = blu;
	tSprite.scalex = tSprite.scaley 	= ONE;
	tSprite.rotate 						= 0;

	tSprite.x 			 				= x;
	tSprite.y							= y;
	
	GsSortFastSprite(&tSprite, &myOT[myActiveBuff], 0);
	
	if (ClipNeeded) {
	
		switch (TimImage.pmode & 3) {
			case 0: // 4-bit
				tSprite.w = TimImage.pw << 2;
				tSprite.u = (TimImage.px & 0x3f) * 4;
				break;
				
			case 1: // 8-bit
				tSprite.w = (TimImage.pw << 1) - 256;
				tSprite.u = ((TimImage.px & 0x3f) * 2) + 256;
				break;
				
			default: // 16-bit
				tSprite.w = ImageWidth;
				tSprite.u = TimImage.px & 0x3f; 
		};
	
		tSprite.x 		= x + 256;
		tSprite.tpage 	= GetTPage((TimImage.pmode & 3), 0, TimImage.px + 128, TimImage.py);
		
		GsSortFastSprite(&tSprite, &myOT[myActiveBuff], 0);
	
	}
	
}

int CollideR(int x, int y, int mx, int my, int *cx) {

	int tx=(x+mx)/16;
	int ty=(y+my)/16;
	int CollideMode=0;
	
	// Clips stuff specifically for the right side of objects
	CollideMode = GetCollideMode(tx, ty);
	if (CollideMode) *cx = (16 * tx) - mx;
	
	return CollideMode;

}
int CollideL(int x, int y, int mx, int my, int *cx) {

	int tx=((x+mx)+1)/16;
	int ty=(y+my)/16;
	int CollideMode=0;
	
	// Clips stuff specifically for the left side of objects
	CollideMode = GetCollideMode(tx, ty);
	if (CollideMode) *cx = ((16 * tx) + 15) - mx;
	
	return CollideMode;

}
int CollideT(int x, int y, int mx, int my, int *cy) {

	int tx=(x+mx)/16;
	int ty=(y+my)/16;
	int CollideMode=0;
	
	// Clips stuff specifically for the top of objects
	CollideMode = GetCollideMode(tx, ty);
	if (CollideMode) *cy = ((16 * ty) + 16) - my;
	
	return CollideMode;

}
int CollideB(int x, int y, int mx, int my, int *cy) {

	int tx=(x+mx)/16;
	int ty=(y+my)/16;
	int CollideMode=0;
	
	// Clips stuff specifically for the bottom of objects
	CollideMode = GetCollideMode(tx, ty);
	if (CollideMode) *cy = (16 * ty) - my;
		
	return CollideMode;

}
int GetCollideMode(int x, int y) {
	
	// Make sure the tile coordinates don't exceed the size of the tilemap
	if (x < 0) return 0;
	if (y < 0) return 0;
	if (x > (LvlHeader_ptr->xdim - 1)) return 0;
	if (y > (LvlHeader_ptr->ydim - 1)) return 0;
	
	// If the tile coords points to a non-zero tile, return it's collide mode
	if (*(LvlData_ptr+(x+(LvlHeader_ptr->xdim*y)))) {
		return(LvlHeader_ptr->TileHitMode[*(LvlData_ptr+(x+(LvlHeader_ptr->xdim*y)))]);
	}
	
	return 0;

}

void LoadVAG(int slot, u_char *vagfile_addr, int vagfile_size) {

	int vag_top;
	int vag_size;

	SpuSetTransferMode(SpuTransByDMA);							// Set transfer mode to DMA
	ss_vag_ptr[slot] = SpuMalloc(vagfile_size - 48);			// Allocate SPU memory for sound
	
	// Set transfer starting address to the memory block
	vag_top = SpuSetTransferStartAddr(ss_vag_ptr[slot]);
	vag_size = SpuWrite(vagfile_addr + 48, vagfile_size - 48);	// Perform actual transfer
	
	SpuIsTransferCompleted(SPU_TRANSFER_WAIT);					// Wait for DMA transfer to complete
	
}
void PlaySound(int slot, int voice, int pitch, int pan) {

	//float pancalc;
	SpuVoiceAttr	VoiceAttr;
	
	// Do not play sound if panning is out of range
	if ((pan < -255) || (pan > 255)) return;

	// Set the voice masks
	VoiceAttr.mask = (
		SPU_VOICE_VOLL |
		SPU_VOICE_VOLR |
		SPU_VOICE_PITCH |
		SPU_VOICE_WDSA |
		SPU_VOICE_ADSR_AMODE |
		SPU_VOICE_ADSR_SMODE |
		SPU_VOICE_ADSR_RMODE |
		SPU_VOICE_ADSR_AR |
		SPU_VOICE_ADSR_DR |
		SPU_VOICE_ADSR_SR |
		SPU_VOICE_ADSR_RR |
		SPU_VOICE_ADSR_SL
	);

	// Calculate panning values
	if (ss_stereo) {
		if (pan < 0) {
			VoiceAttr.volume.left	= 8191;
			VoiceAttr.volume.right	= 8191 * ((ScreenCenterX + pan) / (float)ScreenCenterX);
		} else if (pan > 0) {
			VoiceAttr.volume.left	= 8191 * ((ScreenCenterX - pan) / (float)ScreenCenterX);
			VoiceAttr.volume.right	= 8191;
		} else {
			VoiceAttr.volume.left	= 8191;
			VoiceAttr.volume.right	= 8191;
		}
	} else {
		VoiceAttr.volume.left	= 8191;
		VoiceAttr.volume.right	= 8191;
	}
	
	VoiceAttr.volume.left	*= ((float)ss_sfxvol / 255.0f);
	VoiceAttr.volume.right	*= ((float)ss_sfxvol / 255.0f);
	
	// Set the voice parameters
	if (voice < 0) {
		VoiceAttr.voice	= (0x1L<<ss_nextvoice);
	} else {
		VoiceAttr.voice	= (0x1L<<voice);
	}
	VoiceAttr.pitch			= pitch;
	
	// Other parameters we have little need to fiddle with
	VoiceAttr.addr			= ss_vag_ptr[slot];
	VoiceAttr.a_mode		= SPU_VOICE_LINEARIncN;
	VoiceAttr.s_mode		= SPU_VOICE_LINEARIncN;
	VoiceAttr.r_mode		= SPU_VOICE_LINEARDecN;
	VoiceAttr.ar			= 0x0;
	VoiceAttr.dr			= 0x0;
	VoiceAttr.sr			= 0x0;
	VoiceAttr.rr			= 0x0;
	VoiceAttr.sl			= 0xf;
	
	// Set the attributes then play it!
	SpuSetVoiceAttr(&VoiceAttr);
	
	if (voice < 0) {
		SpuSetKey(SpuOn, 0x1L<<ss_nextvoice);
		ss_nextvoice = (ss_nextvoice + 1) % 24;
	} else
		SpuSetKey(SpuOn, (0x1L<<voice));
	
}

float frand() {
	
	// Simplified random number generator
	
	return((float)rand() / 32767);
	
}
int Inbox(int x, int y, int x1, int y1, int x2, int y2) {
	
	if ((x >= x1) && (x <= x2)) {
		if ((y >= y1) && (y <= y2)) {
			return(true);
		}
	}
	
	return(false);
	
}
int q2sector(int size) {
	
	// Quantizes a value into a multiple of 2048
	
	return 2048*((size+2047)/2048);
	
}
int wrap(int value, int range) {

	if (value >= 0) {
		return value % range;
	} else {
		return ((value + 1) % range) + (range - 1);
	}

}
void ErrorMessage(char *message) {
	
	#if DEBUG == false
	FntLoad(960, 0);
	FntOpen(0, 0, ScreenXres, ScreenYres, 0, 512);
	#endif
	
	ClearColor.red = 0;
	ClearColor.grn = 0;
	ClearColor.blu = 0;
	
	while(1) {
		
		PrepDisplay();
		
		FntPrint("\n\n ERROR:\n %s\n\n SYSTEM HALTED\n", message);
		
		#if DEBUG == false
		FntFlush(-1);
		#endif
		
		Display();
		
	}
	
}
