typedef struct {
	char	Name[16];
	u_long	Size;
	u_long	Addr;
} QLPFILE;


int		QLPfileCount(u_long *qlp_ptr);
QLPFILE	QLPgetFileInfo(u_long *qlp_ptr, int filenum);
u_long	*QLPgetFilePtr(u_long *qlp_ptr, int filenum);
int		QLPsearchFile(u_long *qlp_ptr, char *filename);

int QLPfileCount(u_long *qlp_ptr) {
	
	// Returns the number of files inside a QLP file
	
	// Make sure the file address specified is a QLP file
	if (((u_char*)qlp_ptr)[0] != 'Q') {
		if (((u_char*)qlp_ptr)[1] != 'L') {
			if (((u_char*)qlp_ptr)[2] != 'P') {
				return(0);
			}
			return(0);
		}
		return(0);
	}
	
	// Return the file count
	return(((u_char*)qlp_ptr)[3]);
	
}

QLPFILE QLPgetFileInfo(u_long *qlp_ptr, int filenum) {

	// Make sure the file address specified is a QLP file
	if (((u_char*)qlp_ptr)[0] != 'Q') {
		if (((u_char*)qlp_ptr)[1] != 'L') {
			if (((u_char*)qlp_ptr)[2] != 'P') {
				return;
			}
			return;
		}
		return;
	}
	
	return(((QLPFILE*)(qlp_ptr+1))[filenum]);
	
}

u_long *QLPgetFilePtr(u_long *qlp_ptr, int filenum) {
	
	// Make sure the file address specified is a QLP file
	if (((u_char*)qlp_ptr)[0] != 'Q') {
		if (((u_char*)qlp_ptr)[1] != 'L') {
			if (((u_char*)qlp_ptr)[2] != 'P') {
				return(0);
			}
			return(0);
		}
		return(0);
	}
	
	if (filenum < 0) {
		return(0);
	} else {
		return(qlp_ptr+((QLPFILE*)(qlp_ptr+1))[filenum].Addr);
	}
	
}

int QLPsearchFile(u_long *qlp_ptr, char *FileName) {
	
	int		i;
	char	TempName[16]={0};
	
	// Make sure the file address specified is a QLP file
	if (((u_char*)qlp_ptr)[0] != 'Q') {
		if (((u_char*)qlp_ptr)[1] != 'L') {
			if (((u_char*)qlp_ptr)[2] != 'P') {
				return(0);
			}
			return(0);
		}
		return(0);
	}
	
	// Make the Name of the tile to search upper-cased
	for (i=0; FileName[i] != 0x00; i+=1) {
		TempName[i] = toupper(FileName[i]);
	}
	
	// Scan through the TOC for any matching file names
	for (i=0; i<((u_char*)qlp_ptr)[3]; i+=1) {
		if (strcmp(((QLPFILE*)(qlp_ptr+1))[i].Name, TempName) == 0) {	// Found it!
			return(i);
		}
	}
	
}