typedef struct {
	char up:1;
	char down:1;
	char left:1;
	char right:1;
	char jump:1;
	char run:1;
	char throw:1;
	char swap:1;
	char pause:1;
	char select:1;
	
	char tap_up:1;
	char tap_down:1;
	char tap_left:1;
	char tap_right:1;
	char tap_jump:1;
	char tap_pause:1;
	
} PLAYERINPUT;


// Player data struct
typedef struct {

	// Player coordinates and velocities
	int		x,y;
	int		fx,fy;
	int		xMove,yMove;
	
	// Direction and jump flags
	short	Dir;
	short	Jump;
	short	JumpCount;
	short	JumpPressed;
	
	// Animation
	short	Frame;
	int		FrameCount;
	
	short	Look;
	short	LookCount;
	
	// Collision flags
	short	OldOnFloor;
	short	OnFloor;
	short	Stuck;
	
	// Action flags and counters
	short	Shoot;
	short	ShootPressed;
	short	ShootCount;
	short	ThrowPressed;
	short	ThrowCount;
	
	// Death animation flags and counters
	short	Death;
	short	FallOff;
	short	DeadCount;
	short	DoneFor;
	short	HurtCount;
	short	HitGoal;
	
	// Stats
	short	Lives;
	short	Health;
	short	HealthCoinCount;
	short	PowerState;
	short	FairyMode;
	
	short	DoorEntryState;
	short	DoorEntrySector;
	short	DoorEntryTag;
	
	SPRITE	Sprite;
	
	// Stuff for the fairy companion
	struct {
		
		short	dx,dy;
		short 	x,y;
		int		fx,fy;
		int		xMove,yMove;
		short	Dir;
		
		short	FlutterPressed;
		short	FlutterCount;
		short	DropPressed;
		
		short	LaunchCount;
		short	LaunchPressed;
		
		short	HurtCount;
		
		short	Frame;
		short	FrameCount;
		
		GsSPRITE Sprite;
		
	} Fairy;
	
} PLAYERSTUFF;


// Global player stats
typedef struct {
	short	CoinCount;
	short	KeyCount;
} STATSTRUCT;


typedef struct {
	short	x,y;
	int		fx,fy;
	int		xMove,yMove;
	short	Dir;
	short	Counter;
	short	State;
	short	OnFloor;	
	short	Width;
	short	Height;
	short	Health;
	short	Dead;
	short	Type;
	short	Tag;
} CHARSTRUCT;


typedef struct {
	short	x,y;
	int		fx,fy;
	int		xMove,yMove;
	int		Count;
	u_short	Type;
	u_short	Owner;
} PROJSTRUCT;


typedef struct {
	short	x,y;
	int		fx,fy;
	int		xMove,yMove;
	u_short	Count;
	u_short	Type;
	u_char	r,g,b,p;
	SPRITE	Sprite;
} FXSTRUCT;


typedef struct {
	short	x,y;
	int		fx,fy;
	int		xMove,yMove;
	short	Count;
	short	LifeCount;		
	u_short	Type;
	u_short Flag;
} ENTSTRUCT;